      subroutine gggghns(p1,p2,p3,p4,p,n,c1234)
      implicit none
C---calculates the amplitude squared for the process
c   q(p1)+qbar(p2) --> H((p5+p6)+g(p3)+g(p4)
c   with momentum 4 contracted with the vector n(mu)
c     calculated by the program gggghn.frm
c     one permutation only
      include 'constants.f'
      include 'sprods_com.f'
      integer p1,p2,p3,p4
      double precision p(mxpart,4),n(4),nDn,nDp1,nDp2,nDp3,nDp4
      double precision s123,s124,s234,s134,c1234
      nDp1=n(4)*p(p1,4)-n(3)*p(p1,3)-n(2)*p(p1,2)-n(1)*p(p1,1)
      nDp2=n(4)*p(p2,4)-n(3)*p(p2,3)-n(2)*p(p2,2)-n(1)*p(p2,1)
      nDp3=n(4)*p(p3,4)-n(3)*p(p3,3)-n(2)*p(p3,2)-n(1)*p(p3,1)
      nDp4=n(4)*p(p4,4)-n(3)*p(p4,3)-n(2)*p(p4,2)-n(1)*p(p4,1)
      nDn=n(4)**2-n(3)**2-n(2)**2-n(1)**2
c--- appropriate scale is approx 1d-3*energy(incoming)
c--- so of order(1) for the Tevatron
      if (abs(nDp4).gt.1d-3*abs(p(1,4))) then 
         write(*,*) 'Error for :',p1,p2,p3,p4
         write(*,*) 'cutoff',1d-3*abs(p(1,4))
         write(6,*) 'nDp4',nDp4
         call flush(6)
         stop
      endif
      s123=s(p1,p2)+s(p2,p3)+s(p3,p1)
      s124=s(p1,p2)+s(p2,p4)+s(p4,p1)
      s234=s(p2,p3)+s(p3,p4)+s(p4,p2)
      s134=s(p1,p3)+s(p3,p4)+s(p4,p1)
      c1234=  + nDn*s123**(-2) * (  - 4.D0*s(p1,p4)**2 - 8.D0*s(p1,p4)*
     &    s(p2,p4) - 8.D0*s(p1,p4)*s(p3,p4) - 4.D0*s(p2,p4)**2 - 8.D0*
     &    s(p2,p4)*s(p3,p4) - 4.D0*s(p3,p4)**2 - 2.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p3)**2*s(p1,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p3)**2*s(p1,p4)*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1
     &    ,p3)**2*s(p1,p4)*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,
     &    p3)**2*s(p2,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*
     &    s(p2,p4)*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(
     &    p3,p4)**2 - 4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2 - 8.D0/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4) - 8.D0/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p4)*s(p3,p4) - 4.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 - 8.D
     &    0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4) - 4.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p3,p4)**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)
     &    *s(p2,p4) - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)*
     &    s(p3,p4) )
      c1234 = c1234 + nDn*s123**(-2) * (  - 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4)*s(p3,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*s(p3,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1)*s124**(-1) * ( 4.D0*s(p1,p2)*s(p1,
     &    p3) + 8.D0*s(p1,p2)*s(p3,p4) + 4.D0*s(p1,p3)*s(p1,p4) - 8.D0*
     &    s(p1,p3)*s(p3,p4) - 16.D0*s(p3,p4)**2 - 8.D0/(s(p1,p2))*s(p1,
     &    p3)*s(p1,p4)*s(p3,p4) + 4.D0/(s(p1,p2))*s(p1,p3)*s(p3,p4)**2
     &     + 8.D0/(s(p1,p2))*s(p3,p4)**3 + 4.D0/(s(p1,p2))/(s(p1,p2))*
     &    s(p1,p3)*s(p1,p4)*s(p3,p4)**2 + 4.D0/(s(p1,p4))*s(p1,p2)**2*
     &    s(p1,p3) + 4.D0/(s(p1,p4))*s(p1,p2)**2*s(p3,p4) - 8.D0/(s(p1,
     &    p4))*s(p1,p2)*s(p1,p3)*s(p3,p4) - 8.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p3,p4)**2 + 4.D0/(s(p1,p4))*s(p1,p3)*s(p3,p4)**2 + 4.D0/(s(p1
     &    ,p4))*s(p3,p4)**3 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**4 + 
     &    8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3*s(p3,p4) - 12.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)**2 + 8.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p3,p4)**3 - 2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p3,p4)**4 - 4.D0/(s(p2,p3))*s(p1,p2)**3 - 4.D0/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p4) + 12.D0/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)
     &     + 8.D0/(
     & s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p3,p4) - 12.D0/(s(p2,p3))*s(p1,p2)
     &    *s(p3,p4)**2 - 4.D0/(s(p2,p3))*s(p1,p4)*s(p3,p4)**2 + 4.D0/(
     &    s(p2,p3))*s(p3,p4)**3 )
      c1234 = c1234 + nDn*s123**(-1)*s134**(-1) * (  - 4.D0/(s(p1,p2))*
     &    s(p1,p3)**3 + 8.D0/(s(p1,p2))*s(p1,p3)**2*s(p2,p4) - 4.D0/(s(
     &    p1,p2))*s(p1,p3)*s(p2,p4)**2 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)**4 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3*s(p2,p4)
     &     - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)**2 + 4.D0
     &    /(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)**3 - 2.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p2,p4)**4 - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    **4 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p2,p4) - 12.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2 + 8.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**3 - 2.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p2,p4)**4 - 2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)**2 + 2.D0
     &    /(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 2.D0/(s(p1,p4))*s(p1
     &    ,p3)**3 + 6.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p1,
     &    p4))*s(p2,p4)**3 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(
     &    p1,p3)*s(p2,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p2
     &    ,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1)*s134**(-1) * (  - 6.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) + 10.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)**3 - 2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)**2 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)**3 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**4 + 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)**2 - 4.
     &    D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)*s(p2
     &    ,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2
     &    ,p4)**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p3)**3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p1,p3)**2*s(p2,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)**2 + 2.D0/(s(p2,p3))*s(p1,
     &    p2)**2*s(p1,p3) - 2.D0/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) + 4.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 - 8.D0/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*s(p2,p4) )
      c1234 = c1234 + nDn*s123**(-1)*s134**(-1) * ( 4.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    s(p1,p3) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4) + 
     &    2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2 - 2.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) + 1/(s(p2,p3
     &    ))/(s(p3,p4))*s(p1,p2)**3*s(p1,p3) - 1/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**3*s(p2,p4) - 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(
     &    p1,p3)**2 + 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)**2
     &     - 3.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)
     &     + 5.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2
     &     - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**3 + 2.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**3 - 2.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p2,p4)**4 + 1/(s(p3,p4))*s(p1,p2)**2*s(p1,p3) - 1/(
     &    s(p3,p4))*s(p1,p2)**2*s(p2,p4) - 2.D0/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p3)**2 + 1/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 1/(s(p3
     &    ,p4))*s(p1,p2)*s(p2,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1)*s134**(-1) * (  - 2.D0/(s(p3,p4))*
     &    s(p1,p3)**3 + 4.D0/(s(p3,p4))*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(
     &    p3,p4))*s(p2,p4)**3 )
      c1234 = c1234 + nDn*s123**(-1)*s234**(-1) * (  - 3.D0*s(p1,p2)*s(
     &    p1,p4) + 3.D0*s(p1,p2)*s(p2,p3) + 4.D0*s(p1,p2)*s(p2,p4) - 2.D
     &    0*s(p1,p3)*s(p1,p4) + 2.D0*s(p1,p3)*s(p2,p3) - 11.D0*s(p1,p4)
     &    **2 - 4.D0*s(p1,p4)*s(p2,p4) + 3.D0*s(p2,p3)**2 - 1/(s(p1,p2)
     &    )*s(p1,p3)**2*s(p1,p4) + 1/(s(p1,p2))*s(p1,p3)**2*s(p2,p3) + 
     &    5.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2 - 4.D0/(s(p1,p2))*s(p1,
     &    p3)*s(p1,p4)*s(p2,p3) + 4.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(
     &    p2,p4) - 1/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2 - 4.D0/(s(p1,p2))*
     &    s(p1,p3)*s(p2,p3)*s(p2,p4) + 4.D0/(s(p1,p2))*s(p1,p4)**3 - 3.D
     &    0/(s(p1,p2))*s(p1,p4)**2*s(p2,p3) + 4.D0/(s(p1,p2))*s(p1,p4)
     &    **2*s(p2,p4) - 1/(s(p1,p2))*s(p1,p4)*s(p2,p3)**2 - 4.D0/(s(p1
     &    ,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))
     &    *s(p1,p3)**3*s(p1,p4) + 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**
     &    3*s(p2,p3) - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)*
     &    s(p2,p3) + 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p3)**2
     &     + 2.D0/(
     & s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p1,p4)**2 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p1,p4)*s(p2,p3)
     &     + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p2,p3)
     &    **2 + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,
     &    p4)**2*s(p2,p3) - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)**2*s(p1,p4)*s(p2,p3)**2 + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p2,p3)**3 + 2.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p1,p4)*s(p2,p3) - 2.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)**2*s(p2,p3)**2 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)**3 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2
     &    *s(p2,p3) - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2
     &    ,p3)**2 - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**3 - 2.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**4 + 4.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)**3*s(p2,p3) - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p4)**2*s(p2,p3)**2 - 8.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,
     &    p4) )
      c1234 = c1234 + nDn*s123**(-1)*s234**(-1) * ( 8.D0/(s(p2,p3))*s(
     &    p1,p4)**3 + 4.D0/(s(p2,p3))*s(p1,p4)**2*s(p2,p4) + 4.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2*s(p2,p4) - 1/(s(p3,p4))
     &    *s(p1,p2)**2*s(p1,p4) + 1/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) - 
     &    1/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p1,p4) + 1/(s(p3,p4))*s(p1,
     &    p2)*s(p1,p3)*s(p2,p3) - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)**2
     &     - 1/(s(p3,p4))*s(p1,p2)*s(p1,p4)*s(p2,p3) + 3.D0/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p3)**2 - 2.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2
     &    ,p3) + 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 - 4.D0/(s(p3,p4))
     &    *s(p1,p4)*s(p2,p3)**2 + 4.D0/(s(p3,p4))*s(p2,p3)**3 )
      c1234 = c1234 + nDn*s123**(-1) * (  - 5.D0*s(p1,p2) - 4.D0*s(p1,
     &    p3) - 21.D0*s(p1,p4) + s(p2,p3) - 24.D0*s(p2,p4) - 24.D0*s(p3
     &    ,p4) - 3.D0/(s(p1,p2))*s(p1,p3)**2 - 5.D0/(s(p1,p2))*s(p1,p3)
     &    *s(p1,p4) - 1/(s(p1,p2))*s(p1,p3)*s(p2,p3) + 12.D0/(s(p1,p2))
     &    *s(p1,p3)*s(p2,p4) + 4.D0/(s(p1,p2))*s(p1,p3)*s(p3,p4) + 4.D0
     &    /(s(p1,p2))*s(p1,p4)**2 + 1/(s(p1,p2))*s(p1,p4)*s(p2,p3) + 8.D
     &    0/(s(p1,p2))*s(p1,p4)*s(p2,p4) + 12.D0/(s(p1,p2))*s(p1,p4)*s(
     &    p3,p4) - 2.D0/(s(p1,p2))*s(p2,p4)**2 + 10.D0/(s(p1,p2))*s(p2,
     &    p4)*s(p3,p4) + 14.D0/(s(p1,p2))*s(p3,p4)**2 - 8.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p3)**2*s(p1,p4) - 8.D0/(s(p1,p2))/(s(p1,p2))
     &    *s(p1,p3)**2*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**
     &    2*s(p3,p4) + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4) + 8.D
     &    0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p3,p4) + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p1,p4) - 2.D0/(s(
     &    p1,p2))/(
     & s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p2,p3) + 2.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p2,p4) - 4.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)**2 + 4.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3) - 8.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)
     &     - 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)
     &    **2 + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,
     &    p3)*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p4)**2 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3 - 4.D
     &    0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p1,p2)
     &    )/(s(p1,p4))*s(p1,p3)**2*s(p3,p4) + 8.D0/(s(p1,p2))/(s(p1,p4)
     &    )*s(p1,p3)*s(p2,p4)**2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*
     &    s(p2,p4)*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,
     &    p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**3 - 4.D0/(s(p1,
     &    p2))/(s(p1,p4))*s(p2,p4)**2*s(p3,p4) - 4.D0/(s(p1,p2))/(s(p1,
     &    p4))*s(p2,p4)*s(p3,p4)**2 )
      c1234 = c1234 + nDn*s123**(-1) * (  - 2.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p3,p4)**3 + 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3 - 4.D0/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4) + 2.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p2,p3) - 10.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p4) - 12.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)**2 + 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(
     &    p2,p3) - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p4
     &    ) + 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 - 2.D0/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) + 10.D0/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2 - 6.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p4)**3 + 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(
     &    p2,p3) - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p4) - 8.D
     &    0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2 - 6.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p2,p4)**3 - 2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)
     &     - 2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4) - 6.D0/(s(p1,p4))*s(p1,
     &    p2)*s(p3,p4) )
      c1234 = c1234 + nDn*s123**(-1) * ( 2.D0/(s(p1,p4))*s(p1,p3)**2 + 
     &    4.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4) + 6.D0/(s(p1,p4))*s(p1,p3)*
     &    s(p3,p4) - 10.D0/(s(p1,p4))*s(p2,p4)**2 - 8.D0/(s(p1,p4))*s(
     &    p2,p4)*s(p3,p4) + 2.D0/(s(p1,p4))*s(p3,p4)**2 + 2.D0/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p2)**3 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p3,p4) + 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p4) - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2
     &     - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4) + 6.
     &    D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3,p4)**2 + 2.D0/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 6.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p2,p4)**3 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*s(p3,
     &    p4) - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)**2 - 6.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p3,p4)**3 - 2.D0/(s(p1,p4))/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3) + 4.D0/(s(p1,p4))/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4) + 2.D0/(s(p1,p4))/(s(p2,p3
     &    ))/(
     & s(p2,p3))*s(p1,p2)**3*s(p3,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p3)**2 + 4.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) + 2.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p3,p4) - 4.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 - 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*s(p3,
     &    p4) - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,
     &    p4)**2 - 2.D0/(s(p2,p3))*s(p1,p2)**2 - 4.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3) - 4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4) - 28.D0/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4) - 18.D0/(s(p2,p3))*s(p1,p2)*s(p3,p4
     &    ) + 14.D0/(s(p2,p3))*s(p1,p4)**2 + 18.D0/(s(p2,p3))*s(p1,p4)*
     &    s(p2,p4) + 12.D0/(s(p2,p3))*s(p1,p4)*s(p3,p4) + 2.D0/(s(p2,p3
     &    ))*s(p2,p4)**2 + 12.D0/(s(p2,p3))*s(p2,p4)*s(p3,p4) + 8.D0/(
     &    s(p2,p3))*s(p3,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*s(p1,p4) - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)
     &     - 8.D0/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4) + 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4) + 4.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p2,p4)**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    *s(p2,p4)*s(p3,p4) - 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3 + 
     &    1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3) - 2.D0/(s(p2,p3)
     &    )/(s(p3,p4))*s(p1,p2)**2*s(p1,p4) - 1/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)**2*s(p2,p4) + 3.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p3)*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4
     &    )**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*s(p2,p4)
     &     - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2 - 2.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p4)**3 - 4.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p4)**2*s(p2,p4) - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(
     &    p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3 - 2.D0/(s(
     &    p3,p4))*s(p1,p2)**2 + 1/(s(p3,p4))*s(p1,p2)*s(p1,p3) - 2.D0/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p4) - 3.D0/(s(p3,p4))*s(p1,p2)*s(p2,
     &    p3) )
      c1234 = c1234 + nDn*s123**(-1) * ( 1/(s(p3,p4))*s(p1,p2)*s(p2,p4)
     &     + 2.D0/(s(p3,p4))*s(p1,p3)**2 - 2.D0/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p3) - 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p4) - 4.D0/(s(p3,p4))*
     &    s(p1,p4)**2 + 4.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3) - 8.D0/(s(p3,
     &    p4))*s(p1,p4)*s(p2,p4) - 4.D0/(s(p3,p4))*s(p2,p3)**2 + 4.D0/(
     &    s(p3,p4))*s(p2,p3)*s(p2,p4) - 6.D0/(s(p3,p4))*s(p2,p4)**2 )
      c1234 = c1234 + nDn*s124**(-2) * (  - 6.D0*s(p1,p3)**2 - 12.D0*s(
     &    p1,p3)*s(p2,p3) - 12.D0*s(p1,p3)*s(p3,p4) - 6.D0*s(p2,p3)**2
     &     - 12.D0*s(p2,p3)*s(p3,p4) - 6.D0*s(p3,p4)**2 - 4.D0/(s(p1,p2
     &    ))*s(p1,p3)**2*s(p1,p4) - 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*
     &    s(p2,p3) - 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p3,p4) - 4.D0
     &    /(s(p1,p2))*s(p1,p4)*s(p2,p3)**2 - 8.D0/(s(p1,p2))*s(p1,p4)*
     &    s(p2,p3)*s(p3,p4) - 4.D0/(s(p1,p2))*s(p1,p4)*s(p3,p4)**2 - 2.D
     &    0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)**2 - 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*s(p2,p3) - 4.D0/(s(p1,p2
     &    ))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*s(p3,p4) - 2.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p4)**2*s(p2,p3)**2 - 4.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p4)**2*s(p2,p3)*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p2
     &    ))*s(p1,p4)**2*s(p3,p4)**2 - 4.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3
     &    )**2 - 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 8.D0/(s(
     &    p1,p4))*s(p1,p2)*s(p1,p3)*s(p3,p4) - 4.D0/(s(p1,p4))*s(p1,p2)
     &    *s(p2,p3)**2 )
      c1234 = c1234 + nDn*s124**(-2) * (  - 8.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p2,p3)*s(p3,p4) - 4.D0/(s(p1,p4))*s(p1,p2)*s(p3,p4)**2 - 2.D0
     &    /(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)**2 - 4.D0/(s(p1,
     &    p4))/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p3) - 4.D0/(s(p1,p4
     &    ))/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)*s(p3,p4) - 2.D0/(s(p1,p4))
     &    /(s(p1,p4))*s(p1,p2)**2*s(p2,p3)**2 - 4.D0/(s(p1,p4))/(s(p1,
     &    p4))*s(p1,p2)**2*s(p2,p3)*s(p3,p4) - 2.D0/(s(p1,p4))/(s(p1,p4
     &    ))*s(p1,p2)**2*s(p3,p4)**2 )
      c1234 = c1234 + nDn*s124**(-1)*s134**(-1) * ( 4.D0*s(p1,p2)**2 - 
     &    4.D0*s(p1,p2)*s(p1,p3) + 4.D0*s(p1,p2)*s(p1,p4) + 4.D0*s(p1,
     &    p2)*s(p2,p3) + 12.D0*s(p1,p3)*s(p2,p3) + 4.D0*s(p1,p4)**2 - 4.
     &    D0*s(p1,p4)*s(p2,p3) + 8.D0*s(p2,p3)**2 + 2.D0/(s(p1,p2))*s(
     &    p1,p3)**3 + 2.D0/(s(p1,p2))*s(p1,p3)**2*s(p1,p4) + 4.D0/(s(p1
     &    ,p2))*s(p1,p3)**2*s(p2,p3) + 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4
     &    )**2 + 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2 + 2.D0/(s(p1,p2))
     &    *s(p1,p4)**3 - 4.D0/(s(p1,p2))*s(p1,p4)**2*s(p2,p3) + 4.D0/(
     &    s(p1,p2))*s(p1,p4)*s(p2,p3)**2 + 8.D0/(s(p1,p4))*s(p1,p2)**2*
     &    s(p2,p3) + 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) + 8.D0
     &    /(s(p1,p4))*s(p1,p3)**2*s(p2,p3) + 4.D0/(s(p1,p4))*s(p1,p3)*
     &    s(p2,p3)**2 + 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p3)**2 - 2.D0/(s(p3,p4))*s(p1,p2)**3 + 4.D0/(s(p3,p4))*s(
     &    p1,p2)**2*s(p1,p3) + 4.D0/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) - 4.
     &    D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2 - 8.D0/(s(p3,p4))*s(p1,p2)
     &    *s(p1,p3)*s(p2,p3) )
      c1234 = c1234 + nDn*s124**(-1)*s134**(-1) * (  - 4.D0/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p3)**2 )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * ( 2.D0*s(p1,p2)**2 + 
     &    s(p1,p2)*s(p1,p3) + 3.D0*s(p1,p2)*s(p1,p4) - s(p1,p2)*s(p2,p3
     &    ) + 2.D0*s(p1,p2)*s(p2,p4) + 2.D0*s(p1,p3)**2 + 5.D0*s(p1,p3)
     &    *s(p1,p4) - 2.D0*s(p1,p3)*s(p2,p3) - 2.D0*s(p1,p3)*s(p2,p4)
     &     + 4.D0*s(p1,p4)**2 - 4.D0*s(p1,p4)*s(p2,p3) + 3.D0*s(p1,p4)*
     &    s(p2,p4) + 4.D0*s(p2,p3)**2 + 4.D0*s(p2,p3)*s(p2,p4) + 2.D0*
     &    s(p2,p4)**2 + 2.D0/(s(p1,p2))*s(p1,p3)**2*s(p1,p4) - 1/(s(p1,
     &    p2))*s(p1,p3)*s(p1,p4)**2 + 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)
     &    *s(p2,p3) - 3.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4) + 1/(
     &    s(p1,p2))*s(p1,p4)**3 + 3.D0/(s(p1,p2))*s(p1,p4)**2*s(p2,p4)
     &     + 2.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)**2 + 4.D0/(s(p1,p2))*s(
     &    p1,p4)*s(p2,p4)**2 - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*
     &    s(p1,p4)**2 + 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**3
     &     - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*s(p2,p3)
     &     + 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2*s(p2,p4)
     &     + 2.D0/(
     & s(p1,p2))/(s(p1,p2))*s(p1,p4)**3*s(p2,p3) - 2.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p4)**2*s(p2,p3)**2 + 2.D0/(s(p1,p2))/(s(p1,p2))*
     &    s(p1,p4)**2*s(p2,p3)*s(p2,p4) + 2.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p1,p4)**3 - 2.D0/(s(p1,p2))/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)**2*s(p2,p3) + 4.D0/(s(p1,p2
     &    ))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**3*s(p2,p3) - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,
     &    p3)**2 + 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*s(
     &    p2,p3)**2 - 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2
     &    *s(p2,p3)**3 - 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**
     &    2 + 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)
     &     - 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**3 - 3.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)**2 + 1/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p4)**3*s(p2,p4) - 1/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p4)**2*s(p2,p4)**2 - 1/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)**3*s(p1,p4)**2 )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * (  - 1/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p1,p4)*s(p2,p4) - 1/(s(p1,p2
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**3 - 1/(s(p1,p2
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*s(p2,p4) + 4.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)**2 - 2.D0/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3) + 6.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,p3) - 2.D0/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)**2 + 2.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2 - 5.D0/(s(p1,p4))*s(p1,p2
     &    )**2*s(p1,p3) + 1/(s(p1,p4))*s(p1,p2)**2*s(p2,p3) + 2.D0/(s(
     &    p1,p4))*s(p1,p2)**2*s(p2,p4) + 1/(s(p1,p4))*s(p1,p2)*s(p1,p3)
     &    **2 - 5.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 4.D0/(s(p1
     &    ,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 2.D0/(s(p1,p4))*s(p1,p2)*
     &    s(p2,p3)**2 + 4.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*s(p2,p4) + 2.D
     &    0/(s(p1,p4))*s(p1,p2)*s(p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**3*s(p1,p3)**2 )
      c1234 = c1234 + nDn*s124**(-1)*s234**(-1) * ( 2.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)*s(p2,p4) - 1/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4)**2 - 1/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**3 + 1/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*s(p2,p4) + 
     &    1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,
     &    p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,
     &    p4)**3 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    **3*s(p2,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    *s(p1,p3)**2*s(p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)*s(p1,p3)*s(p2,p4)**3 + 1/(s(p1,p4))/(s(p3,p4))*s(p1
     &    ,p2)**3*s(p1,p3) - 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*s(p2,
     &    p3) - 1/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)**2 - 4.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p3) - 1/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p2,p3)**2 - 3.D0/(s(p1,p4))
     &    /(
     & s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2,p3) - 1/(s(p1,p4))/(s(p3,p4)
     &    )*s(p1,p2)*s(p1,p3)*s(p2,p3)**2 - 2.D0/(s(p2,p3))*s(p1,p2)**2
     &    *s(p2,p4) + 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 - 3.D0/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4) - 6.D0/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*s(p2,p4) - 1/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)
     &     + 1/(s(p2,p3))*s(p1,p3)**2*s(p1,p4) + 2.D0/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4) - 4.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2 - 4.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 6.D0/(s(p2,p3))*s(p1
     &    ,p3)*s(p2,p4)**2 - 1/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2 + 2.D0/(
     &    s(p2,p3))*s(p2,p4)**3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*s(p1,p3)**2 + 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,
     &    p3)*s(p2,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4
     &    )**2 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3 - 6.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p1,p4) + 1/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) + 6.D0/(s(p2
     &    ,p3))/(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*s(p2,p4) + 3.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 - 1/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)**2 - 1/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p2,p4)**3 - 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    **3*s(p1,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4
     &    ) - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2 - 1/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4) + 2.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2 + 2.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(p2,p4) + 2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)**2 + 2.D0/(s(p3,p4))*s(
     &    p1,p2)**2*s(p1,p3) + 1/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2 + 3.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p1,p4) - 6.D0/(s(p3,p4))*s(p1
     &    ,p2)*s(p1,p3)*s(p2,p3) + 1/(s(p3,p4))*s(p1,p2)*s(p1,p4)*s(p2,
     &    p3) - 3.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2 + 4.D0/(s(p3,p4))*
     &    s(p1,p3)**2*s(p1,p4) - 2.D0/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)
     &     + 2.D0/(
     & s(p3,p4))*s(p1,p3)*s(p1,p4)**2 + 2.D0/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)*s(p2,p3) - 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 + 2.D0/(
     &    s(p3,p4))*s(p1,p4)**2*s(p2,p3) - 2.D0/(s(p3,p4))*s(p1,p4)*s(
     &    p2,p3)**2 )
      c1234 = c1234 + nDn*s124**(-1) * ( 6.D0*s(p1,p2) - 28.D0*s(p1,p3)
     &     - 4.D0*s(p1,p4) - 28.D0*s(p2,p3) - 32.D0*s(p3,p4) + 10.D0/(
     &    s(p1,p2))*s(p1,p3)**2 - 20.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4) + 
     &    16.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3) + 18.D0/(s(p1,p2))*s(p1,p3
     &    )*s(p3,p4) - 6.D0/(s(p1,p2))*s(p1,p4)**2 - 6.D0/(s(p1,p2))*s(
     &    p1,p4)*s(p2,p3) - 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4) - 4.D0/(
     &    s(p1,p2))*s(p1,p4)*s(p3,p4) + 4.D0/(s(p1,p2))*s(p2,p3)**2 + 
     &    12.D0/(s(p1,p2))*s(p2,p3)*s(p3,p4) + 14.D0/(s(p1,p2))*s(p3,p4
     &    )**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4) - 8.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2 + 4.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p3) + 8.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p3)*s(p1,p4)*s(p3,p4) - 8.D0/(s(p1,p2))/(s(p1,p2
     &    ))*s(p1,p4)**2*s(p2,p3) - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)
     &    **2*s(p3,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p1,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)*s(p1,p4)**2*s(p2,p3) )
      c1234 = c1234 + nDn*s124**(-1) * (  - 2.D0/(s(p1,p2))/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2 - 4.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p1,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p3,p4) - 1/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**
     &    2 + 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 4.
     &    D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p3,p4) - 4.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)**2 - 1/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**3 + 1/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(
     &    p2,p4) - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p3,p4) + 2.D
     &    0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3,p4)**2 - 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p3,p4)**3 - 6.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3
     &    )**2*s(p1,p4) - 10.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)
     &    *s(p2,p3) - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)**2
     &     + 2.D0/(s(p1,p4))*s(p1,p2)**2 - 8.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p1,p3) - 18.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3) - 2.D0/(s(p1,p4))
     &    *s(p1,p2)*s(p2,p4) )
      c1234 = c1234 + nDn*s124**(-1) * (  - 14.D0/(s(p1,p4))*s(p1,p2)*
     &    s(p3,p4) + 12.D0/(s(p1,p4))*s(p1,p3)**2 + 8.D0/(s(p1,p4))*s(
     &    p1,p3)*s(p2,p3) + 8.D0/(s(p1,p4))*s(p1,p3)*s(p3,p4) + 4.D0/(
     &    s(p1,p4))*s(p2,p3)*s(p3,p4) + 4.D0/(s(p1,p4))*s(p3,p4)**2 - 4.
     &    D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2*s(p1,p3) - 4.D0/(s(p1,p4
     &    ))/(s(p1,p4))*s(p1,p2)**2*s(p2,p3) - 4.D0/(s(p1,p4))/(s(p1,p4
     &    ))*s(p1,p2)**2*s(p3,p4) + 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)
     &    *s(p1,p3)**2 + 8.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*
     &    s(p2,p3) + 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p3,
     &    p4) + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3 - 1/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p3) - 1/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p2,p4) - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p3
     &    ,p4) + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 - 1/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 8.D0/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p3,p4) + 10.D0/(s(p1,p4))
     &    /(
     & s(p2,p3))*s(p1,p2)*s(p3,p4)**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p3)**2*s(p3,p4) - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,
     &    p4)**2 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**3 - 2.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3) + 1/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p2,p4) - 1/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p3,p4) - 2.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2 - 1/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) - 1/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p3,p4) + 
     &    1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 - 
     &    1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*s(p3,
     &    p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    **2*s(p2,p4) + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*s(p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*s(p2,p4)*s(p3,p4) + 2.D0/(s(p1,p4))/(s(p3,p4))*
     &    s(p1,p2)**3 )
      c1234 = c1234 + nDn*s124**(-1) * ( 1/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p2)**2*s(p1,p3) - 3.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p2
     &    ,p3) - 5.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2 - 7.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) + 4.D0/(s(
     &    p2,p3))*s(p1,p2)**2 + 5.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3) + 4.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p4) - 1/(s(p2,p3))*s(p1,p2)*s(p2,p4
     &    ) - 8.D0/(s(p2,p3))*s(p1,p2)*s(p3,p4) + 1/(s(p2,p3))*s(p1,p3)
     &    *s(p1,p4) + 6.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4) - 4.D0/(s(p2,p3
     &    ))*s(p1,p3)*s(p3,p4) + 1/(s(p2,p3))*s(p1,p4)*s(p2,p4) - 8.D0
     &    /(s(p2,p3))*s(p1,p4)*s(p3,p4) - 2.D0/(s(p2,p3))*s(p2,p4)**2
     &     + 2.D0/(s(p2,p3))*s(p2,p4)*s(p3,p4) + 4.D0/(s(p2,p3))*s(p3,
     &    p4)**2 - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3) + 2.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) - 2.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p3,p4) - 4.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p1,p3)**2 - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*s(p1,p4) )
      c1234 = c1234 + nDn*s124**(-1) * (  - 3.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*s(p2,p4) - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    *s(p1,p3)*s(p3,p4) + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4
     &    )*s(p2,p4) - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p3,
     &    p4) + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 - 1/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4) - 2.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)**2*s(p1,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(
     &    p2,p4) + 5.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3) + 3.D0/(s(p3,p4))*
     &    s(p1,p2)*s(p2,p3) - 10.D0/(s(p3,p4))*s(p1,p3)**2 + 2.D0/(s(p3
     &    ,p4))*s(p1,p3)*s(p1,p4) - 18.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)
     &     + 2.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3) - 8.D0/(s(p3,p4))*s(p2,
     &    p3)**2 )
      c1234 = c1234 + nDn*s134**(-2) * (  - 2.D0*s(p1,p2)**2 - 4.D0*s(
     &    p1,p2)*s(p2,p3) - 4.D0*s(p1,p2)*s(p2,p4) - 2.D0*s(p2,p3)**2
     &     - 4.D0*s(p2,p3)*s(p2,p4) - 2.D0*s(p2,p4)**2 - 2.D0/(s(p1,p4)
     &    )/(s(p1,p4))*s(p1,p2)**2*s(p1,p3)**2 - 4.D0/(s(p1,p4))/(s(p1,
     &    p4))*s(p1,p2)*s(p1,p3)**2*s(p2,p3) - 4.D0/(s(p1,p4))/(s(p1,p4
     &    ))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p1,p4))
     &    *s(p1,p3)**2*s(p2,p3)**2 - 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p3
     &    )**2*s(p2,p3)*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p3)
     &    **2*s(p2,p4)**2 - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1
     &    ,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(
     &    p2,p3) - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2
     &    ,p4) - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2 - 4.
     &    D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*s(p2,p4) - 2.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2 )
      c1234 = c1234 + nDn*s134**(-1)*s234**(-1) * (  - s(p1,p2)**2 + 8.D
     &    0*s(p1,p2)*s(p1,p3) - 3.D0*s(p1,p2)*s(p1,p4) + 9.D0*s(p1,p2)*
     &    s(p2,p3) - 6.D0*s(p1,p2)*s(p2,p4) + 6.D0*s(p1,p3)*s(p1,p4) - 
     &    4.D0*s(p1,p3)*s(p2,p3) - 4.D0*s(p1,p3)*s(p2,p4) + 4.D0*s(p1,
     &    p4)**2 - 7.D0*s(p1,p4)*s(p2,p3) - 6.D0*s(p1,p4)*s(p2,p4) + 3.D
     &    0*s(p2,p3)**2 + 6.D0*s(p2,p3)*s(p2,p4) + 2.D0*s(p2,p4)**2 - 4.
     &    D0/(s(p1,p2))*s(p1,p3)**2*s(p2,p4) + 2.D0/(s(p1,p2))*s(p1,p3)
     &    *s(p1,p4)*s(p2,p3) - 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,
     &    p4) - 1/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2 + 2.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p2,p3)*s(p2,p4) + 3.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)
     &    **2 + 2.D0/(s(p1,p2))*s(p1,p4)**2*s(p2,p3) - 3.D0/(s(p1,p2))*
     &    s(p1,p4)*s(p2,p3)**2 - 2.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2
     &    ,p4) + 1/(s(p1,p2))*s(p2,p3)**3 + 1/(s(p1,p2))*s(p2,p3)**2*s(
     &    p2,p4) - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3*s(p2,p4) + 2.D
     &    0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3)*s(p2,p4) + 3.D0
     &    /(
     & s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)**2 - 1/(s(p1,p2))/(s(
     &    p1,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4)**2 - 1/(s(p1,p2))/(s(p1,p4
     &    ))*s(p1,p3)*s(p2,p4)**3 - 4.D0/(s(p1,p4))*s(p1,p2)**2*s(p1,p3
     &    ) - 2.D0/(s(p1,p4))*s(p1,p2)**2*s(p2,p3) + 2.D0/(s(p1,p4))*s(
     &    p1,p2)**2*s(p2,p4) - 2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)**2 - 3.
     &    D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 5.D0/(s(p1,p4))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4) - 1/(s(p1,p4))*s(p1,p2)*s(p2,p3)**2
     &     - 2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*s(p2,p4) + 3.D0/(s(p1,p4
     &    ))*s(p1,p2)*s(p2,p4)**2 - 1/(s(p1,p4))*s(p1,p3)**2*s(p2,p3)
     &     - 3.D0/(s(p1,p4))*s(p1,p3)**2*s(p2,p4) - 1/(s(p1,p4))*s(p1,
     &    p3)*s(p2,p3)**2 - 1/(s(p1,p4))*s(p2,p3)*s(p2,p4)**2 + 1/(s(p1
     &    ,p4))*s(p2,p4)**3 - 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3*s(p1,
     &    p3) + 1/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2 - 4.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4) + 2.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3 - 2.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) )
      c1234 = c1234 + nDn*s134**(-1)*s234**(-1) * (  - 3.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 + 2.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p3)**3*s(p2,p4) - 3.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**3*s(p1,p3)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**3*s(p1,p3)*s(p2,p4) + 1/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p2)**2*s(p1,p3)**3 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p2)**2*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)**2 + 2.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3*s(p2,p4)
     &     - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(
     &    p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p3)*s(p2,p4)**3 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    **3*s(p2,p4)**2 - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    **2*s(p2,p4)**3 - 1/(s(p2,p3))*s(p1,p2)**3 + 7.D0/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p3) )
      c1234 = c1234 + nDn*s134**(-1)*s234**(-1) * ( 2.D0/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p4) - 7.D0/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) + 
     &    10.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 + 7.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*s(p1,p4) - 5.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4) + 3.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2 - 4.D0/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p4)*s(p2,p4) - 3.D0/(s(p2,p3))*s(p1,p2)*s(p2
     &    ,p4)**2 + 2.D0/(s(p2,p3))*s(p1,p3)**3 + 2.D0/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4) + 1/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 2.
     &    D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 1/(s(p2,p3))*s(p1,p4)**2
     &    *s(p2,p4) - 1/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2 + 2.D0/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3) + 1/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**3*s(p1,p4) - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(
     &    p2,p4) + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2
     &     + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p1,p4)
     &     + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)**2 - 1/(s(p2,
     &    p3))/(
     & s(p2,p3))*s(p1,p2)**2*s(p1,p4)*s(p2,p4) + 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)*s(p1,p4)*s(p2,p4) - 1/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 + 1/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p2,p4)**2 + 4.D0/(s(p3,p4))*s(p1,p2)**2*s(p1,p3
     &    ) + 8.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2 + 8.D0/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p3) + 8.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)
     &    **2 + 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p3
     &    ) )
      c1234 = c1234 + nDn*s134**(-1) * (  - 2.D0*s(p1,p2) + 8.D0*s(p1,
     &    p3) + 2.D0*s(p1,p4) - 3.D0*s(p2,p3) - 7.D0*s(p2,p4) + 2.D0/(
     &    s(p1,p2))*s(p1,p3)**2 - 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4) - 8.
     &    D0/(s(p1,p2))*s(p1,p3)*s(p2,p4) - 2.D0/(s(p1,p2))*s(p1,p4)**2
     &     + 6.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3) + 2.D0/(s(p1,p2))*s(p1,
     &    p4)*s(p2,p4) - 5.D0/(s(p1,p2))*s(p2,p3)**2 - 4.D0/(s(p1,p2))*
     &    s(p2,p3)*s(p2,p4) + 2.D0/(s(p1,p2))*s(p2,p4)**2 - 4.D0/(s(p1,
     &    p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3) - 6.D0/(s(p1,p2))/(s(p1,
     &    p4))*s(p1,p3)**2*s(p2,p4) + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,
     &    p3)*s(p2,p3)*s(p2,p4) + 9.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*
     &    s(p2,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p2,p4)**2
     &     - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**3 + 2.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)**3 - 6.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**
     &    2*s(p2,p4) + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2
     &     + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) + 10.
     &    D0/(
     & s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p2,p3)**2*s(p2,p4) - 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p2,p3)*s(p2,p4)**2 - 6.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**3
     &     + 2.D0/(s(p1,p4))*s(p1,p2)**2 + 12.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p1,p3) - 7.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3) - 7.D0/(s(p1,p4))*
     &    s(p1,p2)*s(p2,p4) + 6.D0/(s(p1,p4))*s(p1,p3)**2 + 1/(s(p1,p4)
     &    )*s(p1,p3)*s(p2,p3) + 3.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4) - 3.D0
     &    /(s(p1,p4))*s(p2,p4)**2 + 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)
     &    **2*s(p1,p3) - 4.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)**
     &    2 + 8.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) + 4.
     &    D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 4.D0/(
     &    s(p1,p4))/(s(p1,p4))*s(p1,p3)**2*s(p2,p3) - 4.D0/(s(p1,p4))/(
     &    s(p1,p4))*s(p1,p3)**2*s(p2,p4) + 6.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p3) - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2
     &    *s(p2,p4) + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2
     &     + 8.D0/(
     & s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 8.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 + 4.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)
     &    **3 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)
     &     - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2
     &     + 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)
     &    *s(p2,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2
     &    *s(p2,p4)**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    *s(p1,p3)**2*s(p2,p4) + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4)**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4)**2 + 3.D0/(s(p2,p3))*s(p1,p2)**2 + 
     &    4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3) + 3.D0/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p4) - 1/(s(p2,p3))*s(p1,p2)*s(p2,p4) + 2.D0/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4) - 1/(s(p2,p3))*s(p1,p4)*s(p2,p4) - 2.D0/(s(
     &    p2,p3))*s(p2,p4)**2 + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3 + 
     &    1/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4) + 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p2,p4) + 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4) - 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**
     &    2*s(p1,p3) + 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4) - 2.
     &    D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2 + 7.D0/(s(p2,p3
     &    ))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 5.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)*s(p2,p4)**2 - 2.D0/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)**3 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2
     &     - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3 + 2.D0/(s(p3,p4))*
     &    s(p1,p2)**2 - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3) - 12.D0/(s(p3
     &    ,p4))*s(p1,p2)*s(p2,p3) - 2.D0/(s(p3,p4))*s(p1,p2)*s(p2,p4)
     &     + 6.D0/(s(p3,p4))*s(p1,p3)**2 + 12.D0/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p3) + 4.D0/(s(p3,p4))*s(p1,p3)*s(p2,p4) + 4.D0/(s(p3,p4))*
     &    s(p2,p3)**2 - 4.D0/(s(p3,p4))*s(p2,p3)*s(p2,p4) - 2.D0/(s(p3,
     &    p4))*s(p2,p4)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,
     &    p3)**2 )
      c1234 = c1234 + nDn*s134**(-1) * ( 8.D0/(s(p3,p4))/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p3) - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3
     &    )**2*s(p2,p3) - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,
     &    p4) + 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 + 4.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) )
      c1234 = c1234 + nDn*s234**(-2) * (  - 4.D0*s(p1,p2)**2 - 8.D0*s(
     &    p1,p2)*s(p1,p3) - 8.D0*s(p1,p2)*s(p1,p4) - 4.D0*s(p1,p3)**2
     &     - 8.D0*s(p1,p3)*s(p1,p4) - 4.D0*s(p1,p4)**2 - 2.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p4)*s(p2,p4)**2 - 2.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*s(p1,p4)*s(p2,p4)**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)
     &    **2*s(p2,p4)**2 - 4.D0/(s(p3,p4))*s(p1,p2)**2*s(p2,p3) - 8.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3) - 8.D0/(s(p3,p4))*s(p1
     &    ,p2)*s(p1,p4)*s(p2,p3) - 4.D0/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)
     &     - 8.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3) - 4.D0/(s(p3,p4
     &    ))*s(p1,p4)**2*s(p2,p3) - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)
     &    **2*s(p2,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*
     &    s(p2,p3)**2 )
      c1234 = c1234 + nDn*s234**(-2) * (  - 2.D0/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p3)**2 - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)
     &    *s(p1,p4)*s(p2,p3)**2 - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**
     &    2*s(p2,p3)**2 )
      c1234 = c1234 + nDn*s234**(-1) * (  - 30.D0*s(p1,p2) - 28.D0*s(p1
     &    ,p3) - 36.D0*s(p1,p4) + 6.D0*s(p2,p3) - 3.D0*s(p2,p4) + 2.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4) + 1/(s(p1,p2))*s(p1,p3)*s(p2,p3
     &    ) + 2.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4) - 4.D0/(s(p1,p2))*s(p1,
     &    p4)**2 + 3.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3) + 1/(s(p1,p2))*s(
     &    p2,p3)**2 + 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p1,p4)
     &     - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p3) - 2.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)**2 - 2.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p4)**2*s(p2,p3) - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p1,p4)**2 + 4.D0/(s(p1,p2))/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3) - 2.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2 - 4.D0/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,p3) - 2.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2 + 2.
     &    D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4) - 1/(s(p1,p2))
     &    /(
     & s(p1,p4))*s(p1,p3)*s(p2,p4)**2 - 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1
     &    ,p3)**2*s(p1,p4) - 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,
     &    p4)**2 + 3.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4
     &    ) - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3 - 3.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p4)**2*s(p2,p4) + 1/(s(p1,p2))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)**3*s(p1,p4) + 1/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)**2*s(p1,p4)**2 - 6.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p1,p4) + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2
     &    *s(p2,p3) - 6.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2
     &     + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 - 2.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)**3 + 2.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p4)*s(p2,p3)**2 - 6.D0/(s(p1,p4))*s(p1,p2)**2 - 12.D0/(
     &    s(p1,p4))*s(p1,p2)*s(p1,p3) - 5.D0/(s(p1,p4))*s(p1,p2)*s(p2,
     &    p3) + 1/(s(p1,p4))*s(p1,p2)*s(p2,p4) - 8.D0/(s(p1,p4))*s(p1,
     &    p3)**2 + 1/(s(p1,p4))*s(p1,p3)*s(p2,p3) + 1/(s(p1,p4))*s(p1,
     &    p3)*s(p2,p4) )
      c1234 = c1234 + nDn*s234**(-1) * ( 2.D0/(s(p1,p4))*s(p2,p3)**2 - 
     &    2.D0/(s(p1,p4))*s(p2,p3)*s(p2,p4) + 1/(s(p1,p4))*s(p2,p4)**2
     &     - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3) - 4.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4) - 2.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4) - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3
     &    )**2*s(p2,p4) - 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    3*s(p1,p3) - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*s(p1,p3)*s(p2,p4) - 3.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)**2 + 1/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)**3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)**2*s(p2,p4) - 8.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2 - 5.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2 - 1/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)**2*s(p1,p3) + 1/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p2)**2*s(p2,p3) )
      c1234 = c1234 + nDn*s234**(-1) * ( 1/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p2)*s(p1,p3)**2 - 5.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p3) - 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2
     &     - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) + 2.D0/(s(
     &    p1,p4))/(s(p3,p4))*s(p2,p3)**3 + 1/(s(p2,p3))*s(p1,p2)**2 + 8.
     &    D0/(s(p2,p3))*s(p1,p2)*s(p1,p3) + 9.D0/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p4) - 9.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4) + 4.D0/(s(p2,p3))*
     &    s(p1,p3)**2 + 13.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4) + 4.D0/(s(p2
     &    ,p3))*s(p1,p3)*s(p2,p4) + 14.D0/(s(p2,p3))*s(p1,p4)**2 + 6.D0
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4) - 2.D0/(s(p2,p3))*s(p2,p4)**2
     &     - 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3 - 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p3) - 1/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p1,p4) + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2
     &    ,p4) + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2 - 2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 8.D0/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4) - 7.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p2,p4)**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    **3 + 3.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4) - 2.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 2.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4) - 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)*s(p2,p4)**2 + 7.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3) + 5.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p4) - 18.D0/(s(p3,p4))*s(p1,p2)*s(
     &    p2,p3) + 10.D0/(s(p3,p4))*s(p1,p3)**2 + 6.D0/(s(p3,p4))*s(p1,
     &    p3)*s(p1,p4) - 10.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3) + 6.D0/(s(
     &    p3,p4))*s(p1,p4)**2 - 16.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3) + 2.D
     &    0/(s(p3,p4))*s(p2,p3)**2 + 8.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2
     &    )*s(p1,p3)*s(p2,p3) - 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(
     &    p2,p3)**2 + 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)
     &     + 4.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3) - 4.D
     &    0/(
     & s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2 - 4.D0/(s(p3,p4))/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)**2 )
      c1234 = c1234 + nDn * (  - 49.D0 + 3.D0/(s(p1,p2))*s(p1,p3) + 3.D0
     &    /(s(p1,p2))*s(p1,p4) + 4.D0/(s(p1,p2))*s(p2,p3) - 20.D0/(s(p1
     &    ,p2))*s(p2,p4) + 8.D0/(s(p1,p2))*s(p3,p4) - 2.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p1,p3)**2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*
     &    s(p1,p4) - 2.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2 + 2.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3) - 6.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4) + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2 + 8.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3) + 8.D
     &    0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p4)
     &     - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)
     &     - 2.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p4)**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))/(s(p3
     &    ,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*s(p2,p4) - 2.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2 - 8.D0
     &    /(
     & s(p1,p2))/(s(p1,p4))*s(p1,p3)**2 - 4.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)*s(p2,p3) - 20.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,
     &    p4) - 12.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,p4) - 16.D0/(
     &    s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p2,p4) - 8.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p2,p3)*s(p3,p4) - 24.D0/(s(p1,p2))/(s(p1,p4))*s(p2,
     &    p4)**2 - 24.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)*s(p3,p4) - 8.D0
     &    /(s(p1,p2))/(s(p1,p4))*s(p3,p4)**2 - 8.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4) - 4.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p3)**2*s(p3,p4) - 12.D0/(s(p1,p2))/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 12.D0/(s(p1,p2))/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p2))
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)**2 - 4.D0/(s(p1,p2))
     &    /(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3 - 4.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p2,p3))*s(p2,p4)**2*s(p3,p4) - 4.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p2,p3))*s(p2,p4)*s(p3,p4)**2 - 2.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(
     & s(p2,p3))*s(p3,p4)**3 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2 - 4.D0/(s(p1,p2))/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**3 - 2.D0/(s(p1,p2)
     &    )/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**4 - 8.D0/(s(p1,
     &    p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4) - 8.D0/(s(p1,
     &    p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4) - 12.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p3)*s(p2,p4)**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**3 - 12.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)**2 - 23.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4) - 28.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4) - 20.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4) - 7.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p4)**2 - 14.D0/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p4)*s(p2,p4) - 6.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(
     &    p3,p4) - 10.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2 - 14.D0/(s(
     &    p1,p2))/(
     & s(p2,p3))*s(p2,p4)*s(p3,p4) - 10.D0/(s(p1,p2))/(s(p2,p3))*s(p3,
     &    p4)**2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(
     &    p1,p4) - 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(
     &    p2,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)**2 - 12.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1
     &    ,p4)*s(p2,p4) - 12.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p4)**2 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p4)**3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)**2*s(
     &    p2,p4) - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,
     &    p4)**2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3 - 
     &    2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2 - 4.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4) + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p3) - 6.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)
     &     - 2.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2 + 2.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p4)*s(p2,p3) - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p4)*s(p2,p4) )
      c1234 = c1234 + nDn * ( 4.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2 - 
     &    8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*s(p2,p4) - 18.D0/(s(p1,p2
     &    ))/(s(p3,p4))*s(p2,p4)**2 - 14.D0/(s(p1,p4))*s(p1,p2) + 2.D0
     &    /(s(p1,p4))*s(p1,p3) - 20.D0/(s(p1,p4))*s(p2,p4) - 4.D0/(s(p1
     &    ,p4))*s(p3,p4) - 2.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2 + 8.D0
     &    /(s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p1,p3) - 2.D0/(s(p1,p4))/(
     &    s(p1,p4))*s(p1,p3)**2 - 2.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p3,p4)**2 + 4.D0/(s(p1,p4))/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*s(p3,p4
     &    ) - 2.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    **2*s(p2,p4)**2 + 3.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2 + 7.D
     &    0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3) - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4) + 12.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p3,p4) - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2 - 18.
     &    D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4) - 12.D0/(s(p1,p4))
     &    /(
     & s(p2,p3))*s(p1,p3)*s(p3,p4) - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4
     &    )**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4) - 10.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p3,p4)**2 + 4.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3) - 1/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p2,p4) - 5.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p3,p4) + 2.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)**2 + 7.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4) + 1/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p3,p4) + 4.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2 + 8.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4) - 4.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2 - 8.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4) - 4.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2 - 8.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4) - 12.D0
     &    /(
     & s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2 - 4.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3 - 2.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)**2 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3) + 6.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3) - 2.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p4) + 12.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p3)**2 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*
     &    s(p2,p3) - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4) - 2.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p2,p3)**2 - 2.D0/(s(p1,p4))/(s(p3,p4
     &    ))*s(p2,p3)*s(p2,p4) - 10.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**
     &    2 + 9.D0/(s(p2,p3))*s(p1,p2) - 14.D0/(s(p2,p3))*s(p1,p3) + 7.D
     &    0/(s(p2,p3))*s(p1,p4) + 4.D0/(s(p2,p3))*s(p2,p4) + 6.D0/(s(p2
     &    ,p3))*s(p3,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2 + 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3) + 15.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4) + 1/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p3,p4) + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2 + 2.D0/(
     &    s(p2,p3))/(
     & s(p2,p3))*s(p1,p3)*s(p1,p4) - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4
     &    )**2 + 1/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2 - 6.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3) - 6.D0/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)*s(p1,p4) - 15.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,
     &    p4) - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2 - 14.D0/(s(p2,p3
     &    ))/(s(p3,p4))*s(p1,p3)*s(p1,p4) - 24.D0/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p3)*s(p2,p4) - 10.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)**2
     &     - 20.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4) - 16.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p2,p4)**2 + 1/(s(p3,p4))*s(p1,p2) + 2.D0
     &    /(s(p3,p4))*s(p1,p3) - 4.D0/(s(p3,p4))*s(p1,p4) - 14.D0/(s(p3
     &    ,p4))*s(p2,p3) - 22.D0/(s(p3,p4))*s(p2,p4) - 2.D0/(s(p3,p4))
     &    /(s(p3,p4))*s(p1,p3)**2 + 8.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)
     &    *s(p2,p3) - 2.D0/(s(p3,p4))/(s(p3,p4))*s(p2,p3)**2 )
      c1234 = c1234 + s123**(-1)*s124**(-1) * (  - 8.D0*s(p1,p2)*nDp1*
     &    nDp3 - 8.D0*s(p1,p2)*nDp3**2 + 16.D0*s(p1,p3)*nDp1*nDp3 + 8.D0
     &    *s(p1,p3)*nDp2*nDp3 - 8.D0*s(p1,p3)*nDp3**2 - 16.D0*s(p1,p4)*
     &    nDp1*nDp3 - 8.D0*s(p1,p4)*nDp2*nDp3 - 24.D0*s(p1,p4)*nDp3**2
     &     + 8.D0*s(p3,p4)*nDp1*nDp2 + 24.D0*s(p3,p4)*nDp1*nDp3 + 24.D0
     &    *s(p3,p4)*nDp1**2 - 8.D0*s(p3,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))
     &    *s(p1,p3)**2*nDp1*nDp3 + 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*
     &    nDp3 + 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 8.D0/(s(
     &    p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p1,p3
     &    )*s(p1,p4)*nDp3**2 + 40.D0/(s(p1,p2))*s(p1,p3)*s(p3,p4)*nDp1*
     &    nDp2 + 8.D0/(s(p1,p2))*s(p1,p3)*s(p3,p4)*nDp1*nDp3 + 32.D0/(
     &    s(p1,p2))*s(p1,p3)*s(p3,p4)*nDp1**2 - 8.D0/(s(p1,p2))*s(p1,p3
     &    )*s(p3,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))*s(p1,p3)*s(p3,p4)*
     &    nDp2**2 - 8.D0/(s(p1,p2))*s(p1,p4)**2*nDp1*nDp3 - 8.D0/(s(p1,
     &    p2))*s(p1,p4)**2*nDp2*nDp3 - 16.D0/(s(p1,p2))*s(p1,p4)**2*
     &    nDp3**2 )
      c1234 = c1234 + s123**(-1)*s124**(-1) * ( 24.D0/(s(p1,p2))*s(p1,
     &    p4)*s(p3,p4)*nDp1*nDp2 + 16.D0/(s(p1,p2))*s(p1,p4)*s(p3,p4)*
     &    nDp1*nDp3 + 24.D0/(s(p1,p2))*s(p1,p4)*s(p3,p4)*nDp1**2 - 16.D0
     &    /(s(p1,p2))*s(p1,p4)*s(p3,p4)*nDp2*nDp3 + 16.D0/(s(p1,p2))*s(
     &    p3,p4)**2*nDp1*nDp2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2
     &    *s(p3,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*
     &    s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(
     &    p3,p4)*nDp2**2 + 32.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4
     &    )*s(p3,p4)*nDp1*nDp2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*
     &    s(p1,p4)*s(p3,p4)*nDp1**2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,
     &    p3)*s(p1,p4)*s(p3,p4)*nDp2**2 + 16.D0/(s(p1,p2))/(s(p1,p2))*
     &    s(p1,p4)**2*s(p3,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))*
     &    s(p1,p4)**2*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p4)**2*s(p3,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,
     &    p3)**2*s(p3,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,
     &    p3)**2*s(p3,p4)*nDp1**2 )
      c1234 = c1234 + s123**(-1)*s124**(-1) * ( 8.D0/(s(p1,p2))/(s(p1,
     &    p4))*s(p1,p3)*s(p3,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)**3*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p4)**3*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*
     &    nDp3**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p3,p4)*
     &    nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p3,p4)*
     &    nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p3,p4)*
     &    nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p3,p4)*
     &    nDp2**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p3,p4)**2*
     &    nDp1*nDp2 + 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 + 8.D0
     &    /(s(p1,p4))*s(p1,p2)*s(p3,p4)*nDp1*nDp3 + 8.D0/(s(p1,p4))*s(
     &    p1,p2)*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p4))*s(p1,p3)**2*nDp1*
     &    nDp3 + 8.D0/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp1*nDp2 + 8.D0/(s(
     &    p1,p4))*s(p1,p3)*s(p3,p4)*nDp1*nDp3 + 16.D0/(s(p1,p4))*s(p1,
     &    p3)*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p4))*s(p3,p4)**2*nDp1*nDp2
     &     + 8.D0/(
     & s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp1*nDp3 + 16.D0/(s(p2,p3))*s(p1,p4
     &    )**2*nDp1*nDp3 + 8.D0/(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 8.D0
     &    /(s(p2,p3))*s(p1,p4)**2*nDp3**2 + 8.D0/(s(p2,p3))*s(p1,p4)*s(
     &    p3,p4)*nDp1*nDp2 - 8.D0/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp1*
     &    nDp3 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 4.D0*s(p1,p2)*nDp1*nDp2
     &     + 2.D0*s(p1,p2)*nDp1**2 + 2.D0*s(p1,p2)*nDp2**2 - 2.D0*s(p1,
     &    p2)*nDp3**2 - 4.D0*s(p1,p3)*nDp1*nDp2 - 8.D0*s(p1,p3)*nDp2*
     &    nDp3 + 4.D0*s(p1,p3)*nDp2**2 + 4.D0*s(p1,p4)*nDp1*nDp2 + 4.D0
     &    *s(p1,p4)*nDp2*nDp3 + 4.D0*s(p1,p4)*nDp2**2 - 18.D0*s(p2,p4)*
     &    nDp1*nDp3 - 10.D0*s(p2,p4)*nDp1**2 + 6.D0*s(p2,p4)*nDp2*nDp3
     &     + 2.D0*s(p2,p4)*nDp2**2 - 8.D0*s(p2,p4)*nDp3**2 + 8.D0/(s(p1
     &    ,p2))*s(p1,p3)**2*nDp1*nDp2 + 16.D0/(s(p1,p2))*s(p1,p3)**2*
     &    nDp2**2 + 16.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 + 8.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 16.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)*nDp2**2 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*
     &    nDp1*nDp2 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 16.D
     &    0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1**2 + 16.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p2,p4)*nDp2*nDp3 - 12.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4
     &    )*nDp2**2 + 8.D0/(s(p1,p2))*s(p1,p4)**2*nDp1*nDp2 + 8.D0/(s(
     &    p1,p2))*s(p1,p4)**2*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 8.D0/(s(p1,p2))*s(p1,p4
     &    )**2*nDp2**2 - 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 
     &    8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p1,p2))
     &    *s(p1,p4)*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4
     &    )*nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p2,p4)**2*nDp1*nDp2 + 4.D0/(
     &    s(p1,p2))*s(p2,p4)**2*nDp1**2 - 8.D0/(s(p1,p2))*s(p2,p4)**2*
     &    nDp2*nDp3 + 4.D0/(s(p1,p2))*s(p2,p4)**2*nDp3**2 - 12.D0/(s(p1
     &    ,p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p1,
     &    p2))/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2)
     &    )/(s(p1,p4))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 12.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 8.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p2,p4)**3*nDp3**2 - 4.D0/(s(p1,p2))/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*nDp2**2 - 4.D0/(
     &    s(p1,p2))/(
     & s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*nDp1*nDp3 - 8.D0/(
     &    s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*nDp2*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4
     &    )**3*nDp3**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*nDp2**2
     &     + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2
     &     + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3
     &     - 12.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2
     &     - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2
     &     + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3
     &     + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1**2 - 
     &    8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 + 4.
     &    D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp3**2 - 4.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**3*s(p2,p4)*nDp2*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**3*s(p2
     &    ,p4)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p4)**2*nDp1*nDp2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**3*nDp1**2
     &     - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3
     &     - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 
     &    8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 - 4.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p2,p4)**3*nDp1**2 - 4.D0/(s(p1,p4))*
     &    s(p1,p2)*s(p1,p3)*nDp1*nDp2 - 4.D0/(s(p1,p4))*s(p1,p2)*s(p2,
     &    p4)*nDp1*nDp3 - 4.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp1**2 - 4.
     &    D0/(s(p1,p4))*s(p1,p3)**2*nDp1*nDp2 - 4.D0/(s(p1,p4))*s(p1,p3
     &    )*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1
     &    *nDp3 - 8.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1**2 - 4.D0/(s(
     &    p1,p4))*s(p2,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p3)*nDp1*nDp2 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p3)*nDp1**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 4.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 + 12.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 12.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1**2 + 12.D0/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p3)**3*nDp1*nDp2 + 4.D0/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p3)**3*nDp2**2 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    **2*s(p2,p4)*nDp2*nDp3 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    **2*s(p2,p4)*nDp2**2 - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)**2*nDp3**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp3**2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    s(p1,p3)*nDp1**2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)**3*s(p2,p4)*nDp1**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 8.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp1*nDp2 + 4.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*
     &    nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*
     &    nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p2,p4)**2*nDp1*nDp3 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)*s(p1,p3)**3*nDp1*nDp2 + 4.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)**3*nDp2**2 + 8.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2
     &     - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2
     &    *s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p4))/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp1*
     &    nDp3 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp3**2 - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**3*nDp3**2 + 4.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**4*nDp2**2 + 8.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*nDp2*nDp3
     &     - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)
     &    *nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*
     &    s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p2,p4)**2*nDp3**2 - 4.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)**3*nDp3**2 + 8.D0/(s(p2,p3))*s(
     &    p1,p2)**2*nDp1*nDp2 + 6.D0/(s(p2,p3))*s(p1,p2)**2*nDp1*nDp3
     &     + 6.D0/(s(p2,p3))*s(p1,p2)**2*nDp1**2 + 2.D0/(s(p2,p3))*s(p1
     &    ,p2)**2*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 2.D0/(s(p2,p3))*s(p1,p2
     &    )**2*nDp2**2 - 4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp2 + 
     &    2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1**2 - 8.D0/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*nDp2*nDp3 - 10.D0/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p3)*nDp2**2 - 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp3**2 + 4.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp1*nDp3 + 6.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)
     &    *nDp1**2 + 2.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2 + 2.D0/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3**2 + 4.D0/(s(p2,p3))*s(p1,p3
     &    )**2*nDp1*nDp2 + 8.D0/(s(p2,p3))*s(p1,p3)**2*nDp2**2 + 12.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 + 4.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)
     &    *nDp2**2 + 4.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 14.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 6.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp1**2 + 6.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 18.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p4)**2*nDp1*
     &    nDp2 + 8.D0/(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 8.D0/(s(p2,p3)
     &    )*s(p1,p4)**2*nDp2**2 - 12.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp1*nDp2 + 8.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp3 + 4.D0
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))*s(
     &    p1,p4)*s(p2,p4)*nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp3**2 - 8.D0/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp2 - 4.D0/(s(p2,
     &    p3))*s(p2,p4)**2*nDp1*nDp3 + 4.D0/(s(p2,p3))*s(p2,p4)**2*
     &    nDp1**2 - 16.D0/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)**3*nDp1*nDp2 + 6.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**3*nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**3*nDp1**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*
     &    nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp3**2 - 
     &    8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp2 + 6.
     &    D0/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1**2 - 6.D0/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 8.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp2**2 + 2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp1*nDp2 - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp2 - 6.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 - 6.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp3 - 6.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p2,p4)*nDp3**2 - 12.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)**2*nDp1*nDp2 - 8.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p1,p3)**2*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)*s(p1,p3)**2*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p1,p4)*nDp1*nDp2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2**2 - 6.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 6.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 8.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2**2
     &     - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*
     &    nDp3**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,
     &    p4)*nDp1*nDp2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*
     &    s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1
     &    ,p4)*s(p2,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)**2*nDp1*nDp3 - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)**2*nDp3**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*
     &    nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp1*nDp2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 4.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 8.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp3**2 + 2.D0/(s(p2,
     &    p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*s(p1,p3)*nDp2*nDp3 + 2.
     &    D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*s(p1,p3)*
     &    nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*
     &    s(p2,p4)*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)**2*s(p1,p3)**2*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)**2*s(p1,p3)**2*nDp3**2 + 2.D0/(s(p2,p3))
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp1*
     &    nDp3 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 2.D0/(s(p2,p3))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 2.D0
     &    /(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*s(p2,
     &    p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)
     &    **2*s(p2,p4)**2*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3)
     &    )/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp3**2
     &     + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4)**2*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    s(p1,p3)*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    s(p1,p3)*nDp2*nDp3 - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,
     &    p3)**2*nDp1*nDp3 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,
     &    p3)**2*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * (  - 2.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)**2*nDp3**2 - 10.D0/(s(p2,p3))/(s(p3
     &    ,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 10.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2
     &    ,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp3**2 + 8.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp3 - 2.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p3)**3*nDp2*nDp3 - 2.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp3**2 - 8.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 - 6.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p2,p4)**3*nDp1**2 )
      c1234 = c1234 + s123**(-1)*s134**(-1) * ( 2.D0/(s(p3,p4))*s(p1,p2
     &    )*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2
     &    *nDp3 - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 - 2.D0/(s(
     &    p3,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p3,p4))*s(p1,p2
     &    )*s(p2,p4)*nDp3**2 - 4.D0/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 - 
     &    2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 2.D0/(s(p3,p4))
     &    *s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p3,p4))*s(p1,p3)*s(p2,
     &    p4)*nDp3**2 - 2.D0/(s(p3,p4))*s(p2,p4)**2*nDp1*nDp3 - 2.D0/(
     &    s(p3,p4))*s(p2,p4)**2*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 20.D0*s(p1,p2)*nDp1*
     &    nDp2 + 14.D0*s(p1,p2)*nDp1*nDp3 + 2.D0*s(p1,p2)*nDp1**2 + 6.D0
     &    *s(p1,p2)*nDp2*nDp3 + 2.D0*s(p1,p2)*nDp2**2 + 4.D0*s(p1,p2)*
     &    nDp3**2 + 4.D0*s(p1,p3)*nDp1*nDp2 + 2.D0*s(p1,p3)*nDp1*nDp3
     &     + 2.D0*s(p1,p3)*nDp1**2 + 2.D0*s(p1,p3)*nDp2*nDp3 + 2.D0*s(
     &    p1,p3)*nDp2**2 + 22.D0*s(p1,p4)*nDp1*nDp2 - 6.D0*s(p1,p4)*
     &    nDp1*nDp3 + 20.D0*s(p1,p4)*nDp2*nDp3 + 34.D0*s(p1,p4)*nDp2**2
     &     + 6.D0*s(p1,p4)*nDp3**2 + 6.D0*s(p2,p3)*nDp1*nDp2 + 16.D0*s(
     &    p2,p3)*nDp1*nDp3 + 2.D0*s(p2,p3)*nDp2*nDp3 - 6.D0*s(p2,p3)*
     &    nDp2**2 + 4.D0*s(p2,p3)*nDp3**2 - 16.D0*s(p2,p4)*nDp1*nDp2 - 
     &    4.D0*s(p2,p4)*nDp1*nDp3 - 24.D0*s(p2,p4)*nDp1**2 - 12.D0*s(p2
     &    ,p4)*nDp2*nDp3 - 8.D0*s(p2,p4)*nDp2**2 - 4.D0*s(p2,p4)*
     &    nDp3**2 - 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 + 2.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)*nDp2*nDp3 + 2.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)
     &    *nDp2**2 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 6.D0/(s(p1,p2))*s(p1,p3
     &    )*s(p1,p4)*nDp3**2 - 2.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp1*
     &    nDp2 - 2.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 - 2.D0/(s(
     &    p1,p2))*s(p1,p3)*s(p2,p3)*nDp1**2 - 8.D0/(s(p1,p2))*s(p1,p3)*
     &    s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*
     &    nDp2**2 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp3**2 - 4.D0/(
     &    s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))*s(p1,
     &    p3)*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp2**2 - 4.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp3**2 - 8.D0/(s(p1,p2))*s(p1,
     &    p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))*s(p1,p4)**2*nDp2*nDp3 - 4.D
     &    0/(s(p1,p2))*s(p1,p4)**2*nDp2**2 + 22.D0/(s(p1,p2))*s(p1,p4)*
     &    s(p2,p3)*nDp1*nDp2 - 6.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1*
     &    nDp3 - 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1**2 + 12.D0/(s(
     &    p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 22.D0/(s(p1,p2))*s(p1,
     &    p4)*s(p2,p3)*nDp2**2 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 6.D0/(s(p1,p2))*s(p1,p4
     &    )*s(p2,p3)*nDp3**2 + 24.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp1*
     &    nDp2 - 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(
     &    p1,p2))*s(p1,p4)*s(p2,p4)*nDp1**2 + 12.D0/(s(p1,p2))*s(p1,p4)
     &    *s(p2,p4)*nDp2*nDp3 + 20.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*
     &    nDp2**2 - 6.D0/(s(p1,p2))*s(p2,p3)**2*nDp1*nDp2 + 10.D0/(s(p1
     &    ,p2))*s(p2,p3)**2*nDp1*nDp3 + 2.D0/(s(p1,p2))*s(p2,p3)**2*
     &    nDp1**2 - 4.D0/(s(p1,p2))*s(p2,p3)**2*nDp2*nDp3 - 8.D0/(s(p1,
     &    p2))*s(p2,p3)**2*nDp2**2 - 28.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)
     &    *nDp1*nDp2 - 12.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp1*nDp3 - 
     &    20.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp1**2 - 12.D0/(s(p1,p2))
     &    *s(p2,p3)*s(p2,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p2,p3)*s(p2,
     &    p4)*nDp2**2 - 4.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp3**2 - 20.D
     &    0/(s(p1,p2))*s(p2,p4)**2*nDp1*nDp2 - 12.D0/(s(p1,p2))*s(p2,p4
     &    )**2*nDp1*nDp3 - 20.D0/(s(p1,p2))*s(p2,p4)**2*nDp1**2 + 4.D0
     &    /(
     & s(p1,p2))/(s(p1,p2))*s(p1,p3)**3*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p3)**3*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p3)**3*nDp3**2 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(
     &    p1,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(
     &    p1,p4)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(
     &    p1,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(
     &    p1,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,
     &    p3)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,
     &    p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,
     &    p3)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,
     &    p3)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p3)
     &    *nDp3**2 + 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4)*
     &    nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4)*
     &    nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4)*
     &    nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 4.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p2)
     &    )*s(p1,p3)*s(p1,p4)**2*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p1,p2))
     &    *s(p1,p3)*s(p1,p4)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2
     &    ))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1
     &    ,p2))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1**2 + 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2*
     &    nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2*
     &    nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)**2*
     &    nDp1**2 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 4.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p3)*s(p2,p3)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p2)
     &    )*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2)
     &    )/(s(p1,p2))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp1**2 + 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp2*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)**2*nDp1**2 - 8.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp1*nDp2 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp2**2 + 8.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)**2*nDp1*nDp2 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)**2*nDp1**2 + 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)**2*nDp2**2 + 8.D0/(s(p1,p2)
     &    )/(
     & s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp1**2 + 4.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp2*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp2**2 + 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p2,p3)**3*nDp1**2 - 4.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p2,p3)**2*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p2,p3)**2*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p2,p3)*s(p2,p4)**2*nDp1*nDp2 - 4.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p2,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p2,p3)*s(p2,p4)**2*nDp1**2 - 4.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p1,p4)*nDp3**2 + 4.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*s(p2,p3)*nDp3**2 + 8.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)**2*
     &    nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2
     &    *s(p1,p4)*s(p2,p3)*nDp1*nDp3 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3)*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*s(p2,p3)*nDp3**2 - 8.D
     &    0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)**2*
     &    nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2
     &    *s(p2,p3)**2*nDp3**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*s(p1,p4)**3*nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,p3)*nDp1*nDp2 + 8.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,p3)*nDp2
     &    *nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)**2*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)*s(p1,p4)*s(p2,p3)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)**2*nDp1*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4
     &    )*s(p2,p3)**2*nDp1**2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))
     &    *s(p1,p3)*s(p1,p4)*s(p2,p3)**2*nDp2*nDp3 - 8.D0/(s(p1,p2))/(
     &    s(p1,p2))/(
     & s(p3,p4))*s(p1,p3)*s(p2,p3)**3*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1
     &    ,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**3*nDp1**2 - 4.D0/(s(p1,p2
     &    ))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*s(p2,p3)*nDp2**2 - 8.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2*
     &    nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2
     &    *s(p2,p3)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p4)*s(p2,p3)**3*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p4)*s(p2,p3)**3*nDp1**2 + 4.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p2,p3)**4*nDp1**2 + 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 - 8.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p2,p4)**3*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p2,
     &    p4)**3*nDp1*nDp3 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * (  - 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p2,p4)**3*nDp1**2 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)**2*s(p1,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)**2*s(p1,p4)*nDp3**2 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)*s(p2,p3)*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p3)**2*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p3)**2*nDp3**2 - 4.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p4)**3*nDp2**2 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**
     &    2*s(p2,p3)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2
     &    *s(p2,p3)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*
     &    s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,
     &    p3)**2*nDp1*nDp2 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)**2*nDp1**2 + 12.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p4)*s(p2,p3)**2*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)*s(p2,p3)**2*nDp3**2 + 12.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p2,p3)**3*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3
     &    )**3*nDp1**2 + 8.D0/(s(p2,p3))*s(p1,p2)**2*nDp1*nDp2 + 8.D0/(
     &    s(p2,p3))*s(p1,p2)**2*nDp1*nDp3 + 8.D0/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p4)*nDp1*nDp2 - 8.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp1*
     &    nDp3 + 24.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 + 24.D0/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p2
     &    )*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1
     &    *nDp3 - 8.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1**2 + 16.D0/(s(
     &    p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 16.D0/(s(p2,p3))*s(p1,p4)*s(
     &    p2,p4)*nDp1*nDp2 - 16.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*
     &    nDp3 )
      c1234 = c1234 + s123**(-1)*s234**(-1) * ( 40.D0/(s(p2,p3))*s(p1,
     &    p4)*s(p2,p4)*nDp2*nDp3 + 32.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp3**2 - 8.D0/(
     &    s(p2,p3))*s(p2,p4)**2*nDp1*nDp2 - 8.D0/(s(p2,p3))*s(p2,p4)**2
     &    *nDp1*nDp3 - 16.D0/(s(p2,p3))*s(p2,p4)**2*nDp1**2 + 16.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp3 + 8.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp2**2 + 8.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p4)*nDp3**2 + 32.D0/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 16.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp2**2 + 16.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp3**2 + 
     &    16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 + 
     &    8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 8.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp3**2 + 8.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4)*nDp2*nDp3 + 8.D0/(
     &    s(p2,p3))/(
     & s(p3,p4))*s(p1,p2)**2*s(p1,p4)*nDp3**2 - 8.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p4)**2*nDp2*nDp3 + 8.D0/(s(p3,p4))*s(p1,p2
     &    )**2*nDp1*nDp3 - 10.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp1*nDp3
     &     - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 - 12.D0/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p4)*nDp3**2 + 2.D0/(s(p3,p4))*s(p1,p2)*s(
     &    p2,p3)*nDp1*nDp3 + 2.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp2*
     &    nDp3 + 4.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2 - 2.D0/(s(p3
     &    ,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 - 6.D0/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*
     &    nDp3**2 - 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 + 2.D0
     &    /(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p3,p4))*s(
     &    p1,p4)**2*nDp2*nDp3 - 6.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*
     &    nDp3 + 2.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)*nDp3**2 + 6.D0/(s(p3,p4))*s(p2,p3)
     &    **2*nDp1*nDp3 + 2.D0/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp3 + 4.D0
     &    /(
     & s(p3,p4))*s(p2,p3)**2*nDp3**2 )
      c1234 = c1234 + s123**(-1) * (  - 2.D0*nDp1*nDp2 - 22.D0*nDp1*
     &    nDp3 + 2.D0*nDp1**2 - 8.D0*nDp2*nDp3 + 4.D0*nDp2**2 + 8.D0*
     &    nDp3**2 + 2.D0/(s(p1,p2))*s(p1,p3)*nDp1*nDp2 - 6.D0/(s(p1,p2)
     &    )*s(p1,p3)*nDp1*nDp3 + 2.D0/(s(p1,p2))*s(p1,p3)*nDp1**2 - 12.D
     &    0/(s(p1,p2))*s(p1,p3)*nDp2*nDp3 - 12.D0/(s(p1,p2))*s(p1,p3)*
     &    nDp2**2 + 8.D0/(s(p1,p2))*s(p1,p3)*nDp3**2 - 8.D0/(s(p1,p2))*
     &    s(p1,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))*s(p1,p4)*nDp1*nDp3 - 8.D0
     &    /(s(p1,p2))*s(p1,p4)*nDp2*nDp3 - 20.D0/(s(p1,p2))*s(p1,p4)*
     &    nDp2**2 + 16.D0/(s(p1,p2))*s(p1,p4)*nDp3**2 + 6.D0/(s(p1,p2))
     &    *s(p2,p3)*nDp1*nDp2 + 2.D0/(s(p1,p2))*s(p2,p3)*nDp1*nDp3 + 2.D
     &    0/(s(p1,p2))*s(p2,p3)*nDp1**2 + 4.D0/(s(p1,p2))*s(p2,p3)*nDp2
     &    *nDp3 + 8.D0/(s(p1,p2))*s(p2,p3)*nDp2**2 + 16.D0/(s(p1,p2))*
     &    s(p2,p4)*nDp1*nDp2 - 24.D0/(s(p1,p2))*s(p2,p4)*nDp1*nDp3 + 8.D
     &    0/(s(p1,p2))*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2))*s(p2,p4)*nDp2
     &    *nDp3 + 4.D0/(s(p1,p2))*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))*s(
     &    p3,p4)*nDp1*nDp2 )
      c1234 = c1234 + s123**(-1) * (  - 16.D0/(s(p1,p2))*s(p3,p4)*nDp1*
     &    nDp3 - 16.D0/(s(p1,p2))*s(p3,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p1,p3)**2*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p2))
     &    *s(p1,p3)**2*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)
     &    **2*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*
     &    nDp2**2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*
     &    nDp2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*
     &    nDp3 + 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2**2
     &     - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp1*nDp2 - 4.
     &    D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2**2 - 12.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 16.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 16.D0/(s(p1,
     &    p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1**2 - 16.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p3)*s(p3,p4)*nDp1*nDp2 - 16.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p1,p3)*s(p3,p4)*nDp1**2 + 16.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p4)**2*nDp2**2 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1
     &    ,p4)*s(p2,p3)*nDp2**2 - 32.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*
     &    s(p2,p4)*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(
     &    p3,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p3,
     &    p4)*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p3)*s(p2,p4)*
     &    nDp1*nDp2 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p4)**2*nDp1**2
     &     + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p4)*s(p3,p4)*nDp1**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*nDp3**2 - 8.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp1*
     &    nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1
     &    ,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)**2*s(p1,p4)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)**2*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp3**2 - 8.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp3 + 8.D0/(
     &    s(p1,p2))/(
     & s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp3**2 + 8.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp2 - 
     &    16.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(
     &    p1,p4)**2*nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)*s(p1,p4)*s(p2,p3)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*
     &    nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1
     &    ,p4)*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 16.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp3 - 4.
     &    D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p4
     &    )*nDp1**2 - 16.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp1*nDp3 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp1**2 - 8.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp1*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4)*
     &    nDp1**2 + 16.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p4)**2*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)**3*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2**2 - 16.D0/(s(p1
     &    ,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p4)*nDp1*nDp2 + 
     &    8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p4)*
     &    nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2
     &    ,p3)**2*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p4)*s(p2,p3)**2*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp1*nDp2 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp1**2 - 16.D0/(s(p1,p2))
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2*nDp1*nDp2 + 8.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2*
     &    nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**3*
     &    nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2*
     &    s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2
     &    ,p3)*s(p2,p4)**2*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,
     &    p4))*s(p2,p4)**3*nDp1**2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3
     &    )**2*nDp1*nDp3 + 12.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4
     &    )*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp1*
     &    nDp3 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp1**2
     &     - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**2*nDp1*nDp3 + 8.D0/(
     &    s(p1,p2))/(s(p1,p4))*s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p2))
     &    /(
     & s(p1,p4))*s(p2,p4)*s(p3,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p4
     &    ))*s(p2,p4)*s(p3,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p2,p4)*s(p3,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4)
     &    )/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 + 8.D0/(
     &    s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4
     &    )*s(p3,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4)*s(p3,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p2,p3))*s(p2,p4)**3*nDp3**2 - 8.D0/(s(p1,p2))/(s(p1,p4)
     &    )/(s(p2,p3))*s(p2,p4)**2*s(p3,p4)*nDp1*nDp3 - 16.D0/(s(p1,p2)
     &    )/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*s(p3,p4)*nDp2*nDp3 + 8.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)**2*nDp1*
     &    nDp2 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4
     &    )**2*nDp2**2 )
      c1234 = c1234 + s123**(-1) * (  - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1
     &    ,p3)**2*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4
     &    )*nDp2**2 - 12.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp1*nDp2 - 12.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*
     &    nDp2**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp1*nDp3 - 
     &    16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 16.D
     &    0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 8.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2 + 16.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp3**2 - 16.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p3,p4)*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)*s(p3,p4)*nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p4)*s(p3,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p2
     &    ,p4)**2*nDp1*nDp2 )
      c1234 = c1234 + s123**(-1) * (  - 16.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p2,p4)**2*nDp1*nDp3 + 16.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2
     &    *nDp1**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*nDp3**2 + 
     &    16.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1*nDp2 - 16.D
     &    0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1*nDp3 + 8.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1**2 - 8.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp2*nDp3 + 16.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p3,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p2,p3
     &    ))*s(p3,p4)**2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 4.
     &    D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p4
     &    )*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p4)**2*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 )
      c1234 = c1234 + s123**(-1) * ( 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p4)**2*s(p2,p4)*nDp2**2 - 16.D0/(s(p1,p2
     &    ))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2*nDp1*nDp2 - 8.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)**2*nDp1*
     &    nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3*
     &    nDp1**2 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 - 
     &    4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 - 12.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 8.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp3**2 - 8.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3**2 + 12.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))
     &    *s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    *s(p2,p4)*nDp3**2 )
      c1234 = c1234 + s123**(-1) * ( 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4
     &    )**2*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2**2 - 8.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 + 4.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1**2 - 12.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p4)*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p4)*s(p2,p4)*nDp1**2 + 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(
     &    p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,
     &    p4)*nDp2**2 + 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*
     &    nDp3**2 - 12.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2*nDp1*nDp3
     &     - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2*nDp1**2 + 12.D0/(s(
     &    p1,p2))/(
     & s(p3,p4))*s(p2,p3)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p2,p3)*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p2,p4)**2*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**2*
     &    nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**2*nDp1**2 + 
     &    4.D0/(s(p1,p4))*s(p1,p2)*nDp1*nDp2 + 4.D0/(s(p1,p4))*s(p1,p3)
     &    *nDp1*nDp2 - 8.D0/(s(p1,p4))*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(p1,
     &    p4))*s(p2,p4)*nDp1*nDp2 - 12.D0/(s(p1,p4))*s(p2,p4)*nDp1*nDp3
     &     + 8.D0/(s(p1,p4))*s(p2,p4)*nDp1**2 + 12.D0/(s(p1,p4))*s(p3,
     &    p4)*nDp1*nDp2 - 8.D0/(s(p1,p4))*s(p3,p4)*nDp1*nDp3 + 8.D0/(s(
     &    p1,p4))*s(p3,p4)*nDp1**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2
     &    )**2*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*
     &    nDp1**2 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*
     &    nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp3
     &     + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp1*nDp2 + 
     &    16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp1**2 - 4.D0
     &    /(
     & s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p3)**2*nDp2**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p3)*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4)*nDp2*nDp3 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1*
     &    nDp2 + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2**2
     &     - 20.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp3 + 16.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p2,p4)**2*nDp3**2 + 20.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p2,p4)*s(p3,p4)*nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p2,p4)*s(p3,p4)*nDp1*nDp3 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p2,
     &    p4)*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(
     &    p3,p4)*nDp2*nDp3 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,
     &    p4)*nDp2**2 + 8.D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**2*nDp1*
     &    nDp2 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p3
     &    ,p4)**2*nDp2**2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**3*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p1,p3)*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 + 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*
     &    nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p3,p4)*nDp1*nDp2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p3)**2*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp2**2 - 8.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp2
     &     + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4)*nDp1*nDp3 )
      c1234 = c1234 + s123**(-1) * (  - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2**2 - 
     &    8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p3,
     &    p4)*nDp1*nDp2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p1,p3)*s(p3,p4)*nDp2**2 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3**2 + 
     &    16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3
     &    ,p4)*nDp1*nDp2 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4)*s(p3,p4)*nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4)*nDp2*nDp3 - 4.D0/(s(p1
     &    ,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4)*
     &    nDp2**2 + 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p3,p4)**2*nDp1*nDp2 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p3,p4)**2*nDp2**2 - 4.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)**3*nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 4.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p3,p4)*
     &    nDp2**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2
     &    ,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)**2*nDp3**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p3)*s(p2,p4)*s(p3,p4)*nDp2*nDp3 - 4.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*s(p3,p4)*nDp2**2 - 4.
     &    D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4)**2*
     &    nDp2**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp3**2 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*
     &    s(p3,p4)*nDp2*nDp3 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p2,p4)**2*s(p3,p4)*nDp3**2 )
      c1234 = c1234 + s123**(-1) * (  - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p2,p4)*s(p3,p4)**2*nDp2*nDp3 + 8.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,p4)**2*nDp2**2 + 8.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p3,p4)**3*nDp2**2 - 20.D0/(s(p2,
     &    p3))*s(p1,p2)*nDp1*nDp2 - 32.D0/(s(p2,p3))*s(p1,p2)*nDp1*nDp3
     &     - 4.D0/(s(p2,p3))*s(p1,p2)*nDp2*nDp3 + 12.D0/(s(p2,p3))*s(p1
     &    ,p2)*nDp2**2 - 4.D0/(s(p2,p3))*s(p1,p3)*nDp2*nDp3 - 4.D0/(s(
     &    p2,p3))*s(p1,p3)*nDp2**2 - 24.D0/(s(p2,p3))*s(p1,p4)*nDp1*
     &    nDp2 - 8.D0/(s(p2,p3))*s(p1,p4)*nDp1*nDp3 - 8.D0/(s(p2,p3))*
     &    s(p1,p4)*nDp2*nDp3 - 32.D0/(s(p2,p3))*s(p1,p4)*nDp2**2 + 16.D0
     &    /(s(p2,p3))*s(p2,p4)*nDp1*nDp2 - 40.D0/(s(p2,p3))*s(p2,p4)*
     &    nDp1*nDp3 + 16.D0/(s(p2,p3))*s(p2,p4)*nDp1**2 + 20.D0/(s(p2,
     &    p3))*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p2,p3))*s(p2,p4)*nDp2**2 + 
     &    8.D0/(s(p2,p3))*s(p2,p4)*nDp3**2 + 8.D0/(s(p2,p3))*s(p3,p4)*
     &    nDp1*nDp2 - 8.D0/(s(p2,p3))*s(p3,p4)*nDp2*nDp3 - 20.D0/(s(p2,
     &    p3))*s(p3,p4)*nDp2**2 )
      c1234 = c1234 + s123**(-1) * (  - 12.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*nDp1*nDp2 - 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2
     &    *nDp1*nDp3 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3
     &     + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2**2 + 4.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp2 + 8.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 8.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2**2 - 16.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 - 16.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p2,p4)*nDp1*nDp2 - 16.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp1*nDp3 + 24.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)*nDp2**2 + 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)*nDp3**2 + 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*
     &    nDp1*nDp2 - 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*
     &    nDp2*nDp3 )
      c1234 = c1234 + s123**(-1) * (  - 20.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p3,p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*
     &    nDp2**2 - 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*
     &    nDp3 - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2
     &     + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp2**2 + 16.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp3**2 - 32.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp2*nDp3 + 16.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p3,p4)**2*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)**3*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)**3*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 2.D0/(s(p2,p3))
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 2.D0/(
     &    s(p2,p3))/(
     & s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p2
     &    ,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)*nDp3**2 - 2.D
     &    0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)
     &    *nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)*s(p2,p4)*nDp3**2 - 10.D0/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p2)**2*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1
     &    *nDp3 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*
     &    nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2
     &     + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp1*nDp3 - 4.
     &    D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 + 16.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3**2 + 2.D0/(s(p2
     &    ,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 - 12.D0/(s(p2,p3
     &    ))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2 + 4.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p3)**2*nDp2*nDp3 )
      c1234 = c1234 + s123**(-1) * (  - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1
     &    ,p3)*s(p1,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    *s(p2,p4)*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(
     &    p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,
     &    p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*
     &    nDp3**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2*
     &    nDp3 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2**2
     &     + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp3**2 + 8.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp1*nDp2 - 4.D0/(s(p2,p3)
     &    )/(s(p3,p4))*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p3,p4))*s(p1,p2)
     &    *nDp1*nDp3 - 6.D0/(s(p3,p4))*s(p1,p2)*nDp2*nDp3 - 2.D0/(s(p3,
     &    p4))*s(p1,p2)*nDp3**2 + 2.D0/(s(p3,p4))*s(p1,p3)*nDp1*nDp3 + 
     &    2.D0/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 + 4.D0/(s(p3,p4))*s(p1,p4)
     &    *nDp1*nDp3 - 16.D0/(s(p3,p4))*s(p1,p4)*nDp2*nDp3 + 8.D0/(s(p3
     &    ,p4))*s(p1,p4)*nDp3**2 - 6.D0/(s(p3,p4))*s(p2,p3)*nDp1*nDp3
     &     - 2.D0/(
     & s(p3,p4))*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p3,p4))*s(p2,p3)*nDp3**2
     &     + 14.D0/(s(p3,p4))*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p3,p4))*s(p2
     &    ,p4)*nDp2*nDp3 + 20.D0/(s(p3,p4))*s(p2,p4)*nDp3**2 )
      c1234 = c1234 + s124**(-1)*s134**(-1) * (  - 8.D0*s(p1,p2)*nDp1*
     &    nDp3 - 8.D0*s(p1,p2)*nDp3**2 + 16.D0*s(p1,p3)*nDp1*nDp3 + 8.D0
     &    *s(p1,p3)*nDp2*nDp3 + 8.D0*s(p1,p3)*nDp3**2 + 8.D0*s(p1,p4)*
     &    nDp1*nDp2 - 8.D0*s(p1,p4)*nDp1*nDp3 + 8.D0*s(p1,p4)*nDp2*nDp3
     &     - 8.D0*s(p1,p4)*nDp3**2 - 16.D0*s(p2,p3)*nDp1*nDp2 + 24.D0*
     &    s(p2,p3)*nDp1*nDp3 + 8.D0*s(p2,p3)*nDp1**2 - 16.D0*s(p2,p3)*
     &    nDp2*nDp3 + 16.D0*s(p2,p3)*nDp3**2 - 8.D0/(s(p1,p2))*s(p1,p3)
     &    **2*nDp1*nDp3 - 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp3 - 8.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)
     &    *nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2**2 + 16.D0
     &    /(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp1*nDp2 - 24.D0/(s(p1,p2))*s(
     &    p1,p3)*s(p2,p3)*nDp1*nDp3 - 24.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3
     &    )*nDp2*nDp3 + 16.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2**2 + 8.D
     &    0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 + 8.D0/(s(p1,p2))*s(
     &    p1,p4)*s(p2,p3)*nDp1*nDp3 )
      c1234 = c1234 + s124**(-1)*s134**(-1) * ( 8.D0/(s(p1,p2))*s(p1,p4
     &    )*s(p2,p3)*nDp1**2 + 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2*
     &    nDp3 - 16.D0/(s(p1,p2))*s(p2,p3)**2*nDp1*nDp2 - 16.D0/(s(p1,
     &    p2))*s(p2,p3)**2*nDp1*nDp3 - 16.D0/(s(p1,p2))*s(p2,p3)**2*
     &    nDp1**2 - 16.D0/(s(p1,p2))*s(p2,p3)**2*nDp2*nDp3 - 8.D0/(s(p1
     &    ,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)**2*nDp1*nDp2 - 8.D0/(s(p1,
     &    p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)**2*nDp2**2 + 8.D0/(s(p1,p2)
     &    )/(s(p1,p4))*s(p2,p3)**3*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p4
     &    ))*s(p2,p3)**3*nDp1**2 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    **3*nDp1*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*nDp2*
     &    nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp1*
     &    nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*nDp2*
     &    nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp1*
     &    nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*
     &    nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**3*nDp1*nDp3 - 8.D0
     &    /(
     & s(p1,p2))/(s(p3,p4))*s(p2,p3)**3*nDp2*nDp3 + 8.D0/(s(p1,p4))*s(
     &    p2,p3)**2*nDp1*nDp2 + 8.D0/(s(p1,p4))*s(p2,p3)**2*nDp1*nDp3
     &     - 16.D0/(s(p1,p4))*s(p2,p3)**2*nDp1**2 + 16.D0/(s(p1,p4))*s(
     &    p2,p3)**2*nDp2*nDp3 + 8.D0/(s(p1,p4))/(s(p1,p4))*s(p2,p3)**3*
     &    nDp1**2 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2*
     &    nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2*
     &    nDp3**2 - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)**3*nDp1*nDp3 - 
     &    8.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 - 8.D0/(s(p3,p4))
     &    *s(p1,p2)*s(p1,p3)*nDp3**2 - 16.D0/(s(p3,p4))*s(p1,p2)*s(p2,
     &    p3)*nDp1*nDp3 - 16.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2 + 
     &    16.D0/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 + 8.D0/(s(p3,p4))*s(p1
     &    ,p3)**2*nDp2*nDp3 + 8.D0/(s(p3,p4))*s(p1,p3)**2*nDp3**2 + 40.D
     &    0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 + 16.D0/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p3)*nDp2*nDp3 + 16.D0/(s(p3,p4))*s(p1,p3)*s(p2,
     &    p3)*nDp3**2 + 32.D0/(s(p3,p4))*s(p2,p3)**2*nDp1*nDp3 + 8.D0/(
     &    s(p3,p4))*s(p2,p3)**2*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s134**(-1) * ( 8.D0/(s(p3,p4))*s(p2,p3
     &    )**2*nDp3**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 8.D0*s(p1,p2)*nDp1*
     &    nDp2 - 6.D0*s(p1,p2)*nDp1*nDp3 - 18.D0*s(p1,p2)*nDp1**2 - 6.D0
     &    *s(p1,p2)*nDp2**2 + 12.D0*s(p1,p2)*nDp3**2 - 8.D0*s(p1,p3)*
     &    nDp1*nDp2 - 42.D0*s(p1,p3)*nDp1*nDp3 - 2.D0*s(p1,p3)*nDp1**2
     &     - 14.D0*s(p1,p3)*nDp2*nDp3 - 8.D0*s(p1,p3)*nDp2**2 + 4.D0*s(
     &    p1,p3)*nDp3**2 - 22.D0*s(p1,p4)*nDp1*nDp2 - 16.D0*s(p1,p4)*
     &    nDp1*nDp3 - 32.D0*s(p1,p4)*nDp1**2 - 2.D0*s(p1,p4)*nDp2*nDp3
     &     - 6.D0*s(p1,p4)*nDp2**2 + 8.D0*s(p1,p4)*nDp3**2 + 8.D0*s(p2,
     &    p3)*nDp1*nDp2 + 4.D0*s(p2,p3)*nDp1*nDp3 + 24.D0*s(p2,p3)*
     &    nDp1**2 - 4.D0*s(p2,p3)*nDp2*nDp3 - 12.D0*s(p2,p4)*nDp1*nDp2
     &     + 18.D0*s(p2,p4)*nDp1*nDp3 - 6.D0*s(p2,p4)*nDp1**2 - 4.D0*s(
     &    p2,p4)*nDp2**2 + 4.D0*s(p2,p4)*nDp3**2 + 8.D0/(s(p1,p2))*s(p1
     &    ,p3)**2*nDp1*nDp2 - 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp1*nDp3 + 8.
     &    D0/(s(p1,p2))*s(p1,p3)**2*nDp1**2 - 8.D0/(s(p1,p2))*s(p1,p3)
     &    **2*nDp2*nDp3 - 6.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*nDp2
     &     - 16.D0/(
     & s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))*s(p1,p3)
     &    *s(p1,p4)*nDp1**2 - 20.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2*
     &    nDp3 - 6.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp2**2 - 4.D0/(s(p1
     &    ,p2))*s(p1,p3)*s(p1,p4)*nDp3**2 - 4.D0/(s(p1,p2))*s(p1,p3)*s(
     &    p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp2*
     &    nDp3 - 30.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 12.D0/(
     &    s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 24.D0/(s(p1,p2))*s(p1
     &    ,p3)*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 - 6.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp2**2 - 28.D0
     &    /(s(p1,p2))*s(p1,p4)**2*nDp1*nDp2 - 8.D0/(s(p1,p2))*s(p1,p4)
     &    **2*nDp1*nDp3 - 26.D0/(s(p1,p2))*s(p1,p4)**2*nDp1**2 - 8.D0/(
     &    s(p1,p2))*s(p1,p4)**2*nDp2*nDp3 - 6.D0/(s(p1,p2))*s(p1,p4)**2
     &    *nDp2**2 + 18.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 + 16.D
     &    0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1*nDp3 + 30.D0/(s(p1,p2))*
     &    s(p1,p4)*s(p2,p3)*nDp1**2 - 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)
     &    *nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 24.D0/(s(p1,p2))*s(
     &    p1,p4)*s(p2,p4)*nDp1*nDp2 + 12.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4
     &    )*nDp1*nDp3 - 14.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp1**2 + 8.D
     &    0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p1,p2))*s(
     &    p1,p4)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*
     &    nDp3**2 + 6.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp1*nDp2 + 8.D0
     &    /(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp1*nDp3 + 14.D0/(s(p1,p2))*s(
     &    p2,p3)*s(p2,p4)*nDp1**2 + 4.D0/(s(p1,p2))*s(p2,p4)**2*nDp1*
     &    nDp2 + 8.D0/(s(p1,p2))*s(p2,p4)**2*nDp1*nDp3 + 12.D0/(s(p1,p2
     &    ))*s(p2,p4)**2*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*
     &    s(p1,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*
     &    s(p1,p4)**2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(
     &    p1,p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(
     &    p1,p4)**2*nDp3**2 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,
     &    p4)*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*
     &    s(p1,p4)*s(p2,p4)*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 12.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p4)**3*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2)
     &    )*s(p1,p4)**3*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**
     &    3*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**3*nDp2**2
     &     + 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp1*nDp2
     &     + 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp1*nDp3
     &     + 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp1**2
     &     + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp2*nDp3
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp2**2 + 
     &    4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p3)*nDp3**2 - 16.D
     &    0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p4)*nDp1*nDp2 - 8.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p4)*nDp1**2 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(
     &    p1,p2))/(
     & s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1
     &    ,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*s(p2,p4)*nDp1**2 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p4)**2*nDp1*nDp2 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**3*nDp2*
     &    nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4
     &    )**2*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3
     &    ))*s(p1,p3)*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)**2*nDp2**2 - 
     &    4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**4*nDp1*nDp3
     &     - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**4*nDp2*
     &    nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*s(p2
     &    ,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p4)**3*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)**3*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(
     & s(p2,p3))*s(p1,p4)**3*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)**2*nDp1*nDp2 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)**2*nDp2**2
     &     - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**3
     &    *nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)**3*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))
     &    *s(p1,p3)*s(p1,p4)**3*nDp1**2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p3)*s(p1,p4)**3*nDp2*nDp3 - 4.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**3*nDp2**2 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**3*nDp3**2 + 
     &    8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(
     &    p2,p3)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1
     &    ,p3)*s(p1,p4)**2*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,p3)*nDp1**2 + 8.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,
     &    p3)*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,p3)*nDp2**2 + 4.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*s(p2,
     &    p3)*nDp3**2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)
     &    **3*s(p2,p3)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p4)**3*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)**3*s(p2,p3)*nDp1**2 - 8.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*s(p2,p3)*nDp2*nDp3 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*s(p2,p3)*nDp2**2
     &     - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*s(p2,p3)
     &    *nDp3**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*
     &    s(p2,p3)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))
     &    *s(p1,p4)**2*s(p2,p3)**2*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2
     &    ))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2*nDp1**2 + 8.D0/(s(p1,p2
     &    ))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2*nDp2*nDp3 + 
     &    4.D0/(
     & s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)**2*nDp2**2
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)
     &    **2*nDp3**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*nDp1*
     &    nDp2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*nDp1*nDp3 - 8.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p3)**3*nDp2*nDp3 - 8.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p3)**3*nDp2**2 - 10.D0/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p3)**2*s(p1,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p1,p4)*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p1,p4)*nDp1**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)**2*s(p1,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)**2*s(p1,p4)*nDp2**2 + 6.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)
     &    **2*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)
     &    **2*s(p2,p4)*nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 2.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp2 - 6.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp3 - 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 + 6.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 2.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1**2 + 4.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1**2 - 4.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 - 6.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp1*nDp3 - 4.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p4)**3*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p4)**3*nDp3**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 8.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)**2*s(p2,p4)*nDp1*nDp2 + 6.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)**2*s(p2,p4)*nDp1*nDp3 + 2.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)**2*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p2,p3)
     &    )*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p4)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p4)**2*s(p2,p4)*nDp3**2 - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p4)*s(p2,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p4)*s(p2,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p4)*s(p2,p4)**2*nDp1**2 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)
     &    *s(p2,p4)**2*nDp2*nDp3 - 6.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)
     &    **3*nDp1*nDp2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp1**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*
     &    s(p1,p4)*nDp1*nDp2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)**3*s(p1,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p3)**3*s(p2,p4)*nDp1*nDp2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)**3*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*nDp1*nDp2 + 4.
     &    D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*
     &    nDp1*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2
     &    *s(p1,p4)**2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)**2*s(p1,p4)**2*nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)**2*nDp2**2 + 4.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp1*
     &    nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1
     &    ,p4)*s(p2,p4)*nDp1**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*s(p2,p4)*nDp2**2 - 
     &    4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2
     &    *nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**
     &    2*s(p2,p4)**2*nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**3*nDp1*nDp3 + 4.D0/(s(p1,
     &    p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**3*nDp2*nDp3 + 2.
     &    D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**3*
     &    nDp3**2 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1
     &    ,p4)**2*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p3)*s(p1,p4)**2*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p2))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*s(p2,p4)*nDp3**2
     &     - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(
     &    p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 2.D
     &    0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**3*nDp1*
     &    nDp2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4
     &    )**3*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)
     &    **4*nDp3**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p4)**3*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(
     &    p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**3*s(p2,p4)*nDp3**2 - 
     &    4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)**2
     &    *nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**
     &    2*s(p2,p4)**2*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p4)*s(p2,p4)**3*nDp2**2 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)**3*nDp1*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**3*
     &    nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*
     &    nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*
     &    nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*
     &    nDp1*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*s(p2,p3)*
     &    nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp1*nDp2 - 28.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp1**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 20.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2**2 + 16.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp1*nDp2 + 12.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp1**2 - 8.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp3**2 - 4.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp1*nDp3 - 4.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2*nDp2*nDp3 + 4.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p4)**3*nDp1*nDp3 + 4.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p4)**3*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p4)**3*nDp3**2 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)
     &    **2*s(p2,p3)*nDp1*nDp2 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)
     &    **2*s(p2,p3)*nDp1*nDp3 - 12.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)
     &    **2*s(p2,p3)*nDp1**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 16.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2**2 - 12.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p4)**2*s(p2,p3)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p4)*s(p2,p3)**2*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p4)*s(p2,p3)**2*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4))
     &    *s(p1,p4)*s(p2,p3)**2*nDp1**2 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p4)*s(p2,p3)**2*nDp2*nDp3 - 2.D0/(s(p1,p4))*s(p1,p2)**2*
     &    nDp1*nDp2 + 2.D0/(s(p1,p4))*s(p1,p2)**2*nDp1*nDp3 - 4.D0/(s(
     &    p1,p4))*s(p1,p2)**2*nDp1**2 - 2.D0/(s(p1,p4))*s(p1,p2)**2*
     &    nDp2*nDp3 - 2.D0/(s(p1,p4))*s(p1,p2)**2*nDp2**2 + 4.D0/(s(p1,
     &    p4))*s(p1,p2)**2*nDp3**2 - 2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp1*nDp2 - 16.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 - 2.D
     &    0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp1**2 - 2.D0/(s(p1,p4))*s(p1
     &    ,p2)*s(p1,p3)*nDp2*nDp3 - 2.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*
     &    nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 4.D0/(s(p1,p4))*s(p1,p2
     &    )*s(p1,p3)*nDp3**2 + 2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp1*
     &    nDp2 + 6.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp1**2 - 4.D0/(s(p1
     &    ,p4))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 + 6.D0/(s(p1,p4))*s(p1,p2)*
     &    s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp2*
     &    nDp3 - 2.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1
     &    ,p4))*s(p1,p3)**2*nDp1*nDp2 - 8.D0/(s(p1,p4))*s(p1,p3)**2*
     &    nDp1*nDp3 + 8.D0/(s(p1,p4))*s(p1,p3)**2*nDp1**2 - 4.D0/(s(p1,
     &    p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 - 18.D0/(s(p1,p4))*s(p1,p3)*
     &    s(p2,p4)*nDp1*nDp2 - 12.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1*
     &    nDp3 - 22.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1**2 - 4.D0/(s(
     &    p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p1,p4))*s(p1,p3
     &    )*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1*
     &    nDp2 + 4.D0/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1*nDp3 + 6.D0/(s(
     &    p1,p4))*s(p2,p3)*s(p2,p4)*nDp1**2 + 6.D0/(s(p1,p4))*s(p2,p4)
     &    **2*nDp1*nDp2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 8.D0/(s(p1,p4))*s(p2,p4
     &    )**2*nDp1*nDp3 + 12.D0/(s(p1,p4))*s(p2,p4)**2*nDp1**2 - 2.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3*nDp1*nDp3 - 4.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp2 - 4.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp3 - 4.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1**2 + 4.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp1**2 - 10.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp1*nDp2 - 6.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp1**2 + 12.D0/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 6.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1**2 - 2.D0/(
     &    s(p1,p4))/(
     & s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp2 + 6.D0/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p2)*s(p2,p4)**2*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p3)**3*nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3
     &    )**3*nDp1*nDp3 + 14.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2
     &    ,p4)*nDp1*nDp2 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2
     &    ,p4)*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,
     &    p4)*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2
     &    *nDp1*nDp2 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2
     &    *nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*nDp1*nDp2
     &     + 4.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*nDp1*nDp3 + 2.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*nDp1**2 + 2.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp1*nDp2 + 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*
     &    nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2
     &    *s(p1,p3)**2*nDp1**2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp1*nDp2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 
     &    4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(
     &    p2,p4)*nDp1**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p2,p4)**2*nDp1*nDp2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p2,p4)**2*nDp1*nDp3 + 2.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)**2*nDp1**2 + 2.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**3*nDp1*
     &    nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )**2*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp1*nDp3 + 2.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp1**2
     &     + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4)**2*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp1**2 + 2.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**3*nDp1*nDp3 + 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**3*
     &    nDp1**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*
     &    s(p2,p4)*nDp1*nDp2 - 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)**2*s(p2,p4)**2*nDp1*nDp2 + 6.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)**3*nDp1*nDp2 - 2.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p2,p4)**4*nDp1*nDp2 - 2.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*s(p1,p3)*nDp1*nDp3 - 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)**2*
     &    nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*nDp1*nDp3
     &     - 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*nDp2*nDp3 - 4.D0/(
     &    s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*nDp3**2 - 2.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp3 - 4.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp1**2 - 2.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p4))/(s(
     &    p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 + 8.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p3)*nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p3)*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)**2*s(p2,p3)*nDp3**2 - 6.D0/(s(p1,p4))/(s(p3,p4)
     &    )*s(p1,p2)*s(p1,p3)**2*nDp1*nDp3 + 4.D0/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp1**2 + 2.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp2*nDp3 + 4.D0/(s(p1,p4))/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p3)*nDp3**2 - 4.D0/(s(p1,p4)
     &    )/(s(p3,p4))*s(p1,p2)*s(p2,p3)**2*nDp1*nDp3 - 8.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p1,p3)**3*nDp1*nDp3 - 8.D0/(s(p1,p4))/(s(p3,p4)
     &    )*s(p1,p3)**2*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p3)*s(p2,p3)**2*nDp1*nDp3 + 4.D0/(s(p2,p3))*s(p1,p2)**2
     &    *nDp2*nDp3 + 2.D0/(s(p2,p3))*s(p1,p2)**2*nDp3**2 - 12.D0/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp2 - 10.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*nDp1*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 8.D0/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p3)*nDp1**2 + 6.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp2*nDp3 - 4.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2**2 + 6.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp3**2 + 8.D0/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p4)*nDp1*nDp3 + 12.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*
     &    nDp2*nDp3 + 10.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp3**2 + 8.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 + 18.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)
     &    *nDp1**2 - 20.D0/(s(p2,p3))*s(p1,p3)**2*nDp1*nDp2 - 14.D0/(s(
     &    p2,p3))*s(p1,p3)**2*nDp1*nDp3 - 4.D0/(s(p2,p3))*s(p1,p3)**2*
     &    nDp1**2 + 2.D0/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp3 - 8.D0/(s(p2,
     &    p3))*s(p1,p3)**2*nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p3)**2*
     &    nDp3**2 - 10.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 - 12.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 - 4.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p1,p4)*nDp1**2 + 2.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 8.D0/(s(p2,p3))*s(p1
     &    ,p3)*s(p1,p4)*nDp2**2 + 8.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp3**2 + 16.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 8.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp1**2 - 8.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 - 8.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp3**2 + 4.D0
     &    /(s(p2,p3))*s(p1,p4)**2*nDp1*nDp3 + 8.D0/(s(p2,p3))*s(p1,p4)
     &    **2*nDp2*nDp3 + 12.D0/(s(p2,p3))*s(p1,p4)**2*nDp3**2 + 8.D0/(
     &    s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 26.D0/(s(p2,p3))*s(p1
     &    ,p4)*s(p2,p4)*nDp1*nDp3 + 6.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp1**2 + 4.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp3**2 - 8.D0/(
     &    s(p2,p3))*s(p2,p4)**2*nDp1*nDp2 + 8.D0/(s(p2,p3))*s(p2,p4)**2
     &    *nDp1*nDp3 + 8.D0/(s(p2,p3))*s(p2,p4)**2*nDp1**2 + 4.D0/(s(p2
     &    ,p3))*s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p2,p3))*s(p2,p4)**2*
     &    nDp3**2 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*
     &    nDp1*nDp2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 8.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)**2*nDp1*nDp3 + 6.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)**2*nDp1**2 + 2.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p1,p3)**2*nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 12.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 12.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 8.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1**2 - 4.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2**2
     &     + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2*nDp3**2 - 
     &    2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*nDp1*
     &    nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,p4)*
     &    nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*
     &    nDp1*nDp2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*
     &    nDp1*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p2,p4)**2*nDp1**2 + 2.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)*s(p2,p4)**2*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)**3*nDp1*nDp2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**
     &    3*nDp2**2 + 10.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*
     &    nDp1*nDp2 + 10.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*
     &    nDp1*nDp3 + 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*
     &    nDp1**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*
     &    nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*
     &    nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp1*nDp2 + 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp1**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*
     &    nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*
     &    nDp1*nDp3 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*
     &    nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)**2*nDp3**2 - 10.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1**2 - 8.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 8.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1**2 - 2.D0/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 + 4.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p4)**3*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p4)**2*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)**2*s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)*s(p2,p4)**2*nDp1*nDp2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)*s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)*s(p2,p4)**2*nDp2**2 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p2,p4)**3*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,
     &    p4)**3*nDp2**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*
     &    nDp3**2 - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*
     &    nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*
     &    nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*
     &    nDp3**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p4)*
     &    nDp3**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*
     &    nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)**2*
     &    nDp2*nDp3 - 6.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p1
     &    ,p4)*nDp1*nDp3 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)
     &    *s(p1,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p3)*s(p1,p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)
     &    *s(p1,p4)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2
     &    *s(p1,p4)*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*
     &    s(p1,p4)*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * (  - 2.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 - 6.D0/(s(p3,p4))*s(p1
     &    ,p2)**2*nDp1*nDp3 - 6.D0/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3 - 6.
     &    D0/(s(p3,p4))*s(p1,p2)**2*nDp3**2 - 8.D0/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)*nDp1*nDp2 - 14.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1*
     &    nDp3 - 16.D0/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1**2 - 2.D0/(s(
     &    p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 6.D0/(s(p3,p4))*s(p1,p2
     &    )*s(p1,p3)*nDp3**2 + 4.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp1*
     &    nDp3 - 2.D0/(s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp2*nDp3 + 10.D0/(
     &    s(p3,p4))*s(p1,p2)*s(p1,p4)*nDp3**2 + 6.D0/(s(p3,p4))*s(p1,p2
     &    )*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*
     &    nDp1**2 + 8.D0/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp2*nDp3 + 8.D0
     &    /(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2 - 22.D0/(s(p3,p4))*s(p1
     &    ,p3)**2*nDp1*nDp3 - 6.D0/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 + 8.
     &    D0/(
     & s(p3,p4))*s(p1,p3)**2*nDp3**2 - 24.D0/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)*nDp1*nDp2 - 32.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3
     &     - 24.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1**2 - 12.D0/(s(p3,
     &    p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p3,p4))*s(p1,p3)*
     &    s(p1,p4)*nDp2**2 + 16.D0/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp3**2
     &     + 8.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp2 - 10.D0/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 + 12.D0/(s(p3,p4))*s(p1,p3)*
     &    s(p2,p3)*nDp1**2 - 2.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp2*
     &    nDp3 + 4.D0/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3**2 + 10.D0/(s(
     &    p3,p4))*s(p1,p4)**2*nDp1*nDp3 + 6.D0/(s(p3,p4))*s(p1,p4)**2*
     &    nDp2*nDp3 + 20.D0/(s(p3,p4))*s(p1,p4)**2*nDp3**2 - 8.D0/(s(p3
     &    ,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 - 18.D0/(s(p3,p4))*s(p1,p4)
     &    *s(p2,p3)*nDp1*nDp3 - 12.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*
     &    nDp1**2 - 2.D0/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 4.D0
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp3**2 - 8.D0/(s(p3,p4))*s(p2,
     &    p3)**2*nDp1*nDp3 )
      c1234 = c1234 + s124**(-1)*s234**(-1) * ( 4.D0/(s(p3,p4))*s(p2,p3
     &    )**2*nDp1**2 - 4.D0/(s(p3,p4))*s(p2,p3)**2*nDp2*nDp3 )
      c1234 = c1234 + s124**(-1) * (  - 4.D0*nDp1*nDp2 + 12.D0*nDp1*
     &    nDp3 + 28.D0*nDp1**2 - 8.D0*nDp2*nDp3 + 24.D0*nDp3**2 + 40.D0
     &    /(s(p1,p2))*s(p1,p3)*nDp1*nDp2 - 8.D0/(s(p1,p2))*s(p1,p3)*
     &    nDp1*nDp3 + 16.D0/(s(p1,p2))*s(p1,p3)*nDp1**2 - 8.D0/(s(p1,p2
     &    ))*s(p1,p3)*nDp2*nDp3 + 8.D0/(s(p1,p2))*s(p1,p3)*nDp2**2 + 42.
     &    D0/(s(p1,p2))*s(p1,p4)*nDp1*nDp2 + 24.D0/(s(p1,p2))*s(p1,p4)*
     &    nDp1*nDp3 + 38.D0/(s(p1,p2))*s(p1,p4)*nDp1**2 - 16.D0/(s(p1,
     &    p2))*s(p1,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))*s(p2,p3)*nDp1*nDp2
     &     - 24.D0/(s(p1,p2))*s(p2,p3)*nDp1*nDp3 - 24.D0/(s(p1,p2))*s(
     &    p2,p3)*nDp1**2 + 8.D0/(s(p1,p2))*s(p2,p3)*nDp2*nDp3 - 10.D0/(
     &    s(p1,p2))*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))*s(p2,p4)*nDp1*
     &    nDp3 - 10.D0/(s(p1,p2))*s(p2,p4)*nDp1**2 + 16.D0/(s(p1,p2))*
     &    s(p3,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))*s(p3,p4)*nDp1*nDp3 - 16.D
     &    0/(s(p1,p2))*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p2))*s(p3,p4)*nDp2
     &    *nDp3 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p1,p4)*nDp1*
     &    nDp2 )
      c1234 = c1234 + s124**(-1) * ( 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,
     &    p3)*s(p1,p4)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)
     &    *s(p1,p4)*nDp2**2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p3
     &    ,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p3,p4)
     &    *nDp1**2 + 36.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*nDp1*nDp2
     &     + 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*nDp1*nDp3 + 16.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*nDp1**2 + 16.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p4)**2*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p1,p2
     &    ))*s(p1,p4)**2*nDp2**2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)
     &    *s(p2,p3)*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(
     &    p2,p3)*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,
     &    p3)*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p4)*
     &    nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p3,p4)*
     &    nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p3,p4)*
     &    nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p3)*s(p3,p4)*
     &    nDp1**2 )
      c1234 = c1234 + s124**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp1*nDp2 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp2**2 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp1*
     &    nDp2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2
     &    ,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    *s(p1,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p3)*s(p1,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp1**2 + 8.D0/(s(p1,p2))/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2**2
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2
     &    *nDp3**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*
     &    s(p2,p3)*nDp1*nDp2 )
      c1234 = c1234 + s124**(-1) * ( 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)**2*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp1**2 + 8.D0/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2*nDp3 + 4.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*
     &    s(p2,p3)*nDp3**2 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*
     &    nDp1*nDp2 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*nDp1**2
     &     + 24.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp2 + 
     &    24.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp1**2 + 24.D0
     &    /(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp1*nDp2 + 8.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p2)
     &    )/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp2**2 + 24.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p2,p3)**2*nDp1*nDp2 + 16.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p2,p3)**2*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)**2*
     &    nDp2**2 )
      c1234 = c1234 + s124**(-1) * ( 24.D0/(s(p1,p2))/(s(p1,p4))*s(p2,
     &    p3)*s(p3,p4)*nDp1*nDp2 + 24.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)
     &    *s(p3,p4)*nDp1**2 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p3
     &    ,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p3,p4)**2*nDp1*
     &    nDp2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p3,p4)**2*nDp2**2 + 8.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*nDp1*nDp2 + 8.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**3*nDp1**2 + 16.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p3,p4)*nDp1*
     &    nDp2 + 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(
     &    p3,p4)*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)*s(p3,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)*s(p3,p4)**2*nDp1**2 - 16.D0/(s(p1,p2))/(s(p2,p3
     &    ))*s(p1,p3)**2*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)**2*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*
     &    nDp2*nDp3 - 16.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*nDp2**2
     &     - 6.D0/(
     & s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2
     &    ))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 6.D0/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p3)*s(p1,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,
     &    p3)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2
     &    ,p4)*nDp1**2 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 + 6.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1*
     &    nDp2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1*nDp3
     &     - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2*nDp3 - 8.
     &    D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2**2 - 8.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp1*nDp2 - 8.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p4)**2*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p4)**2*nDp1**2 )
      c1234 = c1234 + s124**(-1) * ( 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4
     &    )**2*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*
     &    nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*
     &    nDp2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp3
     &     - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1**2 + 4.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2 - 6.D0/(s(p1,p2)
     &    )/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp1*nDp2 + 2.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp1**2 + 6.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p2,p4)**2*nDp1*nDp2 - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p2,
     &    p4)**2*nDp1**2 - 6.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)
     &    *nDp1*nDp2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*
     &    nDp1**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*
     &    s(p1,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)**2*s(p1,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 )
      c1234 = c1234 + s124**(-1) * ( 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp2 + 2.D0/(s(p1,p2))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp3 + 4.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2*
     &    nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4
     &    )**2*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *s(p1,p4)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 + 
     &    2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p3,
     &    p4)*nDp1*nDp2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*s(p1,p4)*s(p3,p4)*nDp2**2 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 - 2.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 + 2.D0/(s(p1,
     &    p2))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*s(p3,p4)*nDp1*nDp2 + 2.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*s(p3,p4)*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**3*
     &    nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2
     &    *s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p4)**2*s(p2,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p4)**2*s(p3,p4)*nDp2**2 - 2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2 + 2.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*s(p3,p4)*nDp2**2 + 
     &    16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 + 20.D
     &    0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 12.D0/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1**2 + 12.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2 + 12.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)*nDp3**2 + 4.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p3)*s(p2,p3)*nDp1*nDp3 )
      c1234 = c1234 + s124**(-1) * ( 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3
     &    )*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2
     &    *nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2*nDp3
     &     - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp3**2 + 8.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 + 12.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp3 + 8.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1**2 + 4.D0/(s(p1,p2))/(s(p3
     &    ,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p4)*s(p2,p3)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p2,p3)**2*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2*
     &    nDp2*nDp3 - 2.D0/(s(p1,p4))*s(p1,p2)*nDp1*nDp2 + 4.D0/(s(p1,
     &    p4))*s(p1,p2)*nDp1*nDp3 + 6.D0/(s(p1,p4))*s(p1,p2)*nDp1**2 + 
     &    8.D0/(s(p1,p4))*s(p1,p2)*nDp3**2 + 8.D0/(s(p1,p4))*s(p1,p3)*
     &    nDp1*nDp2 - 40.D0/(s(p1,p4))*s(p1,p3)*nDp1*nDp3 + 16.D0/(s(p1
     &    ,p4))*s(p1,p3)*nDp1**2 + 16.D0/(s(p1,p4))*s(p1,p3)*nDp2*nDp3
     &     + 16.D0/(
     & s(p1,p4))*s(p2,p3)*nDp1*nDp2 - 24.D0/(s(p1,p4))*s(p2,p3)*nDp1*
     &    nDp3 - 8.D0/(s(p1,p4))*s(p2,p3)*nDp1**2 + 32.D0/(s(p1,p4))*s(
     &    p2,p3)*nDp2*nDp3 - 2.D0/(s(p1,p4))*s(p2,p4)*nDp1*nDp2 - 4.D0
     &    /(s(p1,p4))*s(p2,p4)*nDp1*nDp3 - 10.D0/(s(p1,p4))*s(p2,p4)*
     &    nDp1**2 + 8.D0/(s(p1,p4))*s(p3,p4)*nDp1*nDp2 - 24.D0/(s(p1,p4
     &    ))*s(p3,p4)*nDp1*nDp3 + 16.D0/(s(p1,p4))*s(p3,p4)*nDp2*nDp3
     &     + 16.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p3)**2*nDp1**2 + 24.D0/(
     &    s(p1,p4))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp1**2 + 32.D0/(s(p1,
     &    p4))/(s(p1,p4))*s(p1,p3)*s(p3,p4)*nDp1**2 + 16.D0/(s(p1,p4))
     &    /(s(p1,p4))*s(p2,p3)**2*nDp1**2 + 24.D0/(s(p1,p4))/(s(p1,p4))
     &    *s(p2,p3)*s(p3,p4)*nDp1**2 + 16.D0/(s(p1,p4))/(s(p1,p4))*s(p3
     &    ,p4)**2*nDp1**2 + 8.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**3*nDp1**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p3,p4)*nDp1**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)*s(p3,p4)**2*nDp1**2 + 8.D0/(s(p1,p4))/(s(p1,p4)
     &    )/(
     & s(p2,p3))*s(p3,p4)**3*nDp1**2 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p2)**2*nDp1*nDp2 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*
     &    nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp1**2 - 
     &    10.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp2 - 12.D
     &    0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 + 2.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p1
     &    ,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1**2 - 2.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p3,p4)*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p2)*s(p3,p4)*nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p2)*s(p3,p4)*nDp1**2 - 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p3)**2*nDp1*nDp2 - 32.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*
     &    nDp1*nDp3 + 14.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp1*nDp2 + 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp1*nDp3 - 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*
     &    nDp1*nDp2 )
      c1234 = c1234 + s124**(-1) * (  - 40.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p3)*s(p3,p4)*nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p2,
     &    p4)**2*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*
     &    nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1**2 + 
     &    6.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1*nDp2 + 4.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1*nDp3 + 2.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1**2 - 8.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p3,p4)**2*nDp1*nDp2 - 16.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p3,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2
     &    ,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp2 + 4.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1**2 - 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp1*
     &    nDp2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2
     &    ,p4)*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p2,p4)*nDp1**2 )
      c1234 = c1234 + s124**(-1) * ( 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p3,p4)*nDp1*nDp2 + 2.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)*nDp1*nDp3 + 2.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p3,p4)*nDp1**2 + 6.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp1*
     &    nDp2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1**2 + 6.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p3,p4)*nDp1
     &    *nDp2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)**2*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)*s(p2,p4)**2*nDp1**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p2,p4)*s(p3,p4)*nDp1*nDp3 + 2.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*s(p3,p4)*nDp1**2 + 2.D0
     &    /(
     & s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)**2*nDp1*nDp2
     &     + 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)
     &    *nDp1*nDp2 - 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p2,p4)**2*nDp1*nDp2 + 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)*s(p3,p4)*nDp1*nDp2 + 2.D0/(s(p1,p4))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p2,p4)**3*nDp1*nDp2 - 2.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p2,p4)**2*s(p3,p4)*nDp1*nDp2 + 2.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,p4)**2*nDp1*nDp2
     &     - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)
     &    *nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)**2*nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**
     &    2*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*nDp2*
     &    nDp3 - 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*nDp3**2 + 12.D0
     &    /(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1**2 - 2.D0/(s(p1,p4)
     &    )/(
     & s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p3,p4
     &    ))*s(p1,p2)*s(p1,p3)*nDp3**2 + 20.D0/(s(p1,p4))/(s(p3,p4))*s(
     &    p1,p2)*s(p2,p3)*nDp1*nDp3 + 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p2)*s(p2,p3)*nDp3**2 - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)**2
     &    *nDp1*nDp3 - 20.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp1*nDp3 - 16.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)**2*nDp1*nDp3
     &     - 4.D0/(s(p2,p3))*s(p1,p2)*nDp1*nDp2 - 12.D0/(s(p2,p3))*s(p1
     &    ,p2)*nDp1*nDp3 - 6.D0/(s(p2,p3))*s(p1,p2)*nDp1**2 + 4.D0/(s(
     &    p2,p3))*s(p1,p2)*nDp2*nDp3 + 2.D0/(s(p2,p3))*s(p1,p2)*nDp2**2
     &     + 4.D0/(s(p2,p3))*s(p1,p2)*nDp3**2 - 16.D0/(s(p2,p3))*s(p1,
     &    p3)*nDp1*nDp2 - 16.D0/(s(p2,p3))*s(p1,p3)*nDp1*nDp3 + 4.D0/(
     &    s(p2,p3))*s(p1,p3)*nDp1**2 + 12.D0/(s(p2,p3))*s(p1,p3)*nDp2*
     &    nDp3 - 2.D0/(s(p2,p3))*s(p1,p3)*nDp2**2 + 16.D0/(s(p2,p3))*s(
     &    p1,p3)*nDp3**2 - 6.D0/(s(p2,p3))*s(p1,p4)*nDp1*nDp2 - 18.D0/(
     &    s(p2,p3))*s(p1,p4)*nDp1*nDp3 - 6.D0/(s(p2,p3))*s(p1,p4)*
     &    nDp1**2 )
      c1234 = c1234 + s124**(-1) * ( 8.D0/(s(p2,p3))*s(p1,p4)*nDp2*nDp3
     &     + 4.D0/(s(p2,p3))*s(p1,p4)*nDp2**2 + 4.D0/(s(p2,p3))*s(p1,p4
     &    )*nDp3**2 + 8.D0/(s(p2,p3))*s(p2,p4)*nDp1*nDp2 - 6.D0/(s(p2,
     &    p3))*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p2,p3))*s(p2,p4)*nDp1**2 - 
     &    4.D0/(s(p2,p3))*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))*s(p2,p4)
     &    *nDp2**2 - 4.D0/(s(p2,p3))*s(p2,p4)*nDp3**2 - 8.D0/(s(p2,p3))
     &    *s(p3,p4)*nDp1*nDp2 - 4.D0/(s(p2,p3))*s(p3,p4)*nDp1*nDp3 + 4.D
     &    0/(s(p2,p3))*s(p3,p4)*nDp1**2 + 8.D0/(s(p2,p3))*s(p3,p4)*nDp2
     &    *nDp3 + 8.D0/(s(p2,p3))*s(p3,p4)*nDp3**2 + 12.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp2 + 12.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 + 8.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)*s(p1,p3)*nDp1**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p4)*nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2
     &    ,p4)*nDp1*nDp2 )
      c1234 = c1234 + s124**(-1) * (  - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    *s(p2,p4)*nDp1**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,
     &    p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*
     &    nDp1*nDp2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp1
     &    *nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp1**2
     &     + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp2**2 + 10.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp1*nDp2 + 4.D0/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p3)**2*nDp2**2 + 10.D0/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 + 10.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p3)*s(p1,p4)*nDp1**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1
     &    ,p4)*nDp2**2 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp1**2 )
      c1234 = c1234 + s124**(-1) * ( 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*s(p2,p4)*nDp2**2 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3
     &    ,p4)*nDp1*nDp2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4)
     &    *nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*nDp1*nDp3
     &     + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 - 2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2 + 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p4)*s(p3,p4)*nDp1*nDp2 + 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p4)*s(p3,p4)*nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p4)*s(p3,p4)*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,
     &    p4)**2*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*
     &    nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1*
     &    nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp2**2
     &     + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p3,p4)**2*nDp1*nDp2 + 2.D0/(
     &    s(p2,p3))/(
     & s(p3,p4))*s(p1,p2)**2*nDp3**2 - 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,
     &    p2)*s(p1,p3)*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1
     &    ,p3)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*
     &    nDp3**2 - 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 - 
     &    2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 - 2.D0/(s(p2
     &    ,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 - 2.D0/(s(p2,p3)
     &    )/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 10.D0/(s(p3,p4))*
     &    s(p1,p2)*nDp1*nDp3 - 4.D0/(s(p3,p4))*s(p1,p2)*nDp2*nDp3 - 8.D0
     &    /(s(p3,p4))*s(p1,p2)*nDp3**2 + 8.D0/(s(p3,p4))*s(p1,p3)*nDp1*
     &    nDp2 + 18.D0/(s(p3,p4))*s(p1,p3)*nDp1*nDp3 + 12.D0/(s(p3,p4))
     &    *s(p1,p3)*nDp1**2 + 6.D0/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 + 12.D0
     &    /(s(p3,p4))*s(p1,p3)*nDp3**2 - 10.D0/(s(p3,p4))*s(p1,p4)*nDp1
     &    *nDp3 - 6.D0/(s(p3,p4))*s(p1,p4)*nDp2*nDp3 - 12.D0/(s(p3,p4))
     &    *s(p1,p4)*nDp3**2 + 8.D0/(s(p3,p4))*s(p2,p3)*nDp1*nDp3 + 4.D0
     &    /(
     & s(p3,p4))*s(p2,p3)*nDp1**2 + 4.D0/(s(p3,p4))*s(p2,p3)*nDp2*nDp3
     &     + 16.D0/(s(p3,p4))*s(p2,p3)*nDp3**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 16.D0*s(p1,p2)*nDp1*
     &    nDp2 + 8.D0*s(p1,p2)*nDp1**2 - 12.D0*s(p1,p2)*nDp2*nDp3 + 8.D0
     &    *s(p1,p2)*nDp3**2 - 10.D0*s(p1,p3)*nDp1*nDp2 - 28.D0*s(p1,p3)
     &    *nDp1*nDp3 - 16.D0*s(p1,p3)*nDp1**2 + 8.D0*s(p1,p3)*nDp2*nDp3
     &     + 8.D0*s(p1,p3)*nDp2**2 - 8.D0*s(p1,p3)*nDp3**2 + 10.D0*s(p1
     &    ,p4)*nDp1*nDp2 - 16.D0*s(p1,p4)*nDp1*nDp3 - 8.D0*s(p1,p4)*
     &    nDp1**2 + 4.D0*s(p1,p4)*nDp2*nDp3 + 2.D0*s(p1,p4)*nDp2**2 - 8.
     &    D0*s(p1,p4)*nDp3**2 - 16.D0*s(p2,p3)*nDp1*nDp2 + 10.D0*s(p2,
     &    p3)*nDp1*nDp3 + 12.D0*s(p2,p3)*nDp1**2 - 8.D0*s(p2,p3)*nDp2*
     &    nDp3 - 2.D0*s(p2,p3)*nDp2**2 + 8.D0*s(p2,p3)*nDp3**2 - 12.D0*
     &    s(p2,p4)*nDp1*nDp2 + 20.D0*s(p2,p4)*nDp1*nDp3 + 18.D0*s(p2,p4
     &    )*nDp1**2 - 6.D0*s(p2,p4)*nDp2*nDp3 - 2.D0*s(p2,p4)*nDp2**2
     &     + 12.D0*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p2))*s(p1,p3)**2*nDp1*
     &    nDp2 + 8.D0/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp3 + 2.D0/(s(p1,p2)
     &    )*s(p1,p3)**2*nDp2**2 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p1,p4)*
     &    nDp1*nDp2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 2.D0/(s(p1,p2))*s(p1,p3
     &    )*s(p1,p4)*nDp2**2 - 12.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp1*
     &    nDp3 - 8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p3)*nDp1**2 - 4.D0/(s(p1
     &    ,p2))*s(p1,p3)*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p1,p2))*s(p1,p3)*
     &    s(p2,p3)*nDp3**2 + 8.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*
     &    nDp3 + 12.D0/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1**2 + 4.D0/(s(
     &    p1,p2))*s(p1,p3)*s(p2,p4)*nDp3**2 - 8.D0/(s(p1,p2))*s(p1,p4)
     &    **2*nDp1*nDp2 - 4.D0/(s(p1,p2))*s(p1,p4)**2*nDp2*nDp3 + 2.D0
     &    /(s(p1,p2))*s(p1,p4)**2*nDp2**2 + 12.D0/(s(p1,p2))*s(p1,p4)*
     &    s(p2,p3)*nDp1*nDp2 - 8.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1*
     &    nDp3 - 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1**2 + 4.D0/(s(p1
     &    ,p2))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 + 2.D0/(s(p1,p2))*s(p1,p4)*
     &    s(p2,p3)*nDp2**2 - 4.D0/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp3**2
     &     + 12.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,
     &    p2))*s(p1,p4)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))*s(p1,p4)*
     &    s(p2,p4)*nDp1**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 10.D0/(s(p1,p2))*s(p1,
     &    p4)*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p1,p2))*s(p1,p4)*s(p2,p4)*
     &    nDp2**2 - 4.D0/(s(p1,p2))*s(p2,p3)**2*nDp1*nDp2 + 8.D0/(s(p1,
     &    p2))*s(p2,p3)**2*nDp1*nDp3 + 6.D0/(s(p1,p2))*s(p2,p3)**2*
     &    nDp1**2 + 4.D0/(s(p1,p2))*s(p2,p3)**2*nDp3**2 - 12.D0/(s(p1,
     &    p2))*s(p2,p3)*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p1,p2))*s(p2,p3)*
     &    s(p2,p4)*nDp1*nDp3 - 4.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*
     &    nDp1**2 - 2.D0/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp2*nDp3 + 4.D0
     &    /(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp3**2 - 8.D0/(s(p1,p2))*s(p2,
     &    p4)**2*nDp1*nDp2 - 8.D0/(s(p1,p2))*s(p2,p4)**2*nDp1*nDp3 - 6.D
     &    0/(s(p1,p2))*s(p2,p4)**2*nDp1**2 - 2.D0/(s(p1,p2))*s(p2,p4)**
     &    2*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3*nDp1*
     &    nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3*nDp2*nDp3 + 2.D0
     &    /(s(p1,p2))/(s(p1,p4))*s(p1,p3)**3*nDp2**2 - 8.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p1,p3)**2*s(p2,p3)*nDp1*nDp2 - 4.D0/(s(p1,p2))
     &    /(
     & s(p1,p4))*s(p1,p3)**2*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1
     &    ,p4))*s(p1,p3)**2*s(p2,p3)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p4
     &    ))*s(p1,p3)**2*s(p2,p3)*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p4)
     &    )*s(p1,p3)**2*s(p2,p3)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)**2*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)**2*s(p2,p4)*nDp1**2 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)**2*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,
     &    p3)**2*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)
     &    *s(p2,p3)**2*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*
     &    s(p2,p3)**2*nDp1*nDp3 + 6.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*
     &    s(p2,p3)**2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(
     &    p2,p3)*s(p2,p4)*nDp1*nDp2 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,
     &    p3)*s(p2,p3)*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p4))*
     &    s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp2*nDp3 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p1,p3)*s(p2,p3)*s(p2,p4)*nDp3**2 - 4.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 + 2.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp1**2 - 2.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p1,p3)*s(p2,p4)**2*nDp3**2 - 2.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p2,p3)**3*nDp1**2 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(p2
     &    ,p3)**2*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p2,
     &    p3)**2*s(p2,p4)*nDp1**2 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)
     &    *s(p2,p4)**2*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*
     &    s(p2,p4)**2*nDp1**2 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**3*
     &    nDp1*nDp3 - 6.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**3*nDp1**2 - 
     &    4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2
     &    *nDp1**2 + 2.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)**3*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4)**3*nDp1**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 2.D0/(s(p1,p2))/(s(
     &    p1,p4))/(s(p2,p3))*s(p2,p4)**4*nDp1*nDp3 - 4.D0/(s(p1,p2))/(
     &    s(p1,p4))/(s(p2,p3))*s(p2,p4)**4*nDp1**2 - 4.D0/(s(p1,p2))/(
     &    s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 + 12.D0/(s(p1,p2))/(s(p2
     &    ,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1
     &    ,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 - 8.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 + 4.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(
     &    s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1**2 - 4.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp2**2 + 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p2,p4)**3*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p2,p4)**3*nDp1**2 - 8.D0/(s(p1,p4))*s(p1,p2)**2*nDp1*nDp2 + 
     &    16.D0/(s(p1,p4))*s(p1,p2)**2*nDp1*nDp3 + 6.D0/(s(p1,p4))*s(p1
     &    ,p2)**2*nDp1**2 - 4.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp1*nDp2
     &     - 8.D0/(s(p1,p4))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 + 12.D0/(s(p1,
     &    p4))*s(p1,p2)*s(p1,p3)*nDp1**2 + 4.D0/(s(p1,p4))*s(p1,p2)*s(
     &    p2,p3)*nDp1*nDp2 + 16.D0/(s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp1*
     &    nDp3 - 8.D0/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 + 20.D0/(
     &    s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p4))*s(p1,
     &    p2)*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p4))*s(p1,p3)**2*nDp1*nDp2
     &     - 12.D0/(s(p1,p4))*s(p1,p3)**2*nDp1*nDp3 - 8.D0/(s(p1,p4))*
     &    s(p1,p3)**2*nDp1**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 4.D0/(s(p1,p4))*s(p1,p3
     &    )**2*nDp2*nDp3 + 2.D0/(s(p1,p4))*s(p1,p3)**2*nDp2**2 + 6.D0/(
     &    s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 + 12.D0/(s(p1,p4))*s(p1
     &    ,p3)*s(p2,p3)*nDp1**2 - 4.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*
     &    nDp2*nDp3 - 2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp2**2 + 4.D0
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 16.D0/(s(p1,p4))*s(
     &    p1,p3)*s(p2,p4)*nDp1*nDp3 + 36.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4
     &    )*nDp1**2 - 2.D0/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 2.D0
     &    /(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p4))*s(p1,
     &    p3)*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p4))*s(p2,p3)**2*nDp1*nDp2
     &     + 6.D0/(s(p1,p4))*s(p2,p3)**2*nDp1*nDp3 - 4.D0/(s(p1,p4))*s(
     &    p2,p3)**2*nDp1**2 + 4.D0/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1*
     &    nDp2 + 10.D0/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1*nDp3 - 8.D0/(
     &    s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1**2 - 2.D0/(s(p1,p4))*s(p2,p3
     &    )*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p4))*s(p2,p3)*s(p2,p4)*
     &    nDp3**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 4.D0/(s(p1,p4))*s(p2
     &    ,p4)**2*nDp1*nDp2 - 2.D0/(s(p1,p4))*s(p2,p4)**2*nDp1*nDp3 - 
     &    18.D0/(s(p1,p4))*s(p2,p4)**2*nDp1**2 - 2.D0/(s(p1,p4))*s(p2,
     &    p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p4))*s(p2,p4)**2*nDp3**2 - 8.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)**3*nDp1*nDp2 - 6.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p1,p2)**3*nDp1*nDp3 - 6.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp2 - 6.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p1,p3)*nDp1**2 - 16.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)*nDp1*nDp2 - 10.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p2,p4)*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp1*nDp3 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)**2*nDp1**2 + 28.D0/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p3)*s(p2,p4)*nDp1**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 12.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp2 - 6.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp3 - 12.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp3 - 16.D0/(s(p1,p4))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4)*nDp1**2 + 6.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 + 32.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)**2*nDp1**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p2,p4)**3*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp1*nDp3 - 14.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*nDp1**2
     &     - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*s(p1,p3)
     &    *nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    3*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p3)**2*nDp1*nDp2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 2.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*nDp1*nDp3 - 2.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)**2*
     &    nDp1**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 2.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*s(p2,p4)*
     &    nDp1**2 + 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*
     &    s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*s(p2,p4)*nDp1*nDp3
     &     - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2
     &    *s(p2,p4)*nDp1**2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 - 2.D0/(s(p1,p4))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 + 4.D
     &    0/(
     & s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)**2*
     &    nDp1**2 + 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2
     &    ,p4)**3*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)**2*s(p2,p4)**2*nDp1*nDp2 - 2.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*nDp1*nDp3 - 2.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)**2*nDp1**2 + 2.D
     &    0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**3*nDp1*
     &    nDp2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4
     &    )**3*nDp1**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)
     &    **4*nDp1*nDp3 - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**3*nDp1*
     &    nDp3 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p2,p3)*nDp1*
     &    nDp3 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*s(p2,p3)*
     &    nDp1**2 + 4.D0/(s(p2,p3))*s(p1,p2)**2*nDp1*nDp2 + 4.D0/(s(p2,
     &    p3))*s(p1,p2)**2*nDp1*nDp3 + 4.D0/(s(p2,p3))*s(p1,p2)**2*
     &    nDp1**2 - 12.D0/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3 - 14.D0/(s(
     &    p2,p3))*s(p1,p2)**2*nDp3**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 20.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p3)*nDp1*nDp2 - 24.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )*nDp1*nDp3 - 20.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1**2 + 4.D
     &    0/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 14.D0/(s(p2,p3))*
     &    s(p1,p2)*s(p1,p3)*nDp2**2 - 8.D0/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    *nDp3**2 - 10.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp1*nDp2 - 16.D
     &    0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp1*nDp3 - 8.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p1,p4)*nDp1**2 - 8.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*
     &    nDp2*nDp3 + 2.D0/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2**2 - 8.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp3**2 + 18.D0/(s(p2,p3))*s(p1
     &    ,p2)*s(p2,p4)*nDp1*nDp2 + 22.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*
     &    nDp1*nDp3 + 20.D0/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1**2 + 8.D0
     &    /(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp3**2 + 10.D0/(s(p2,p3))*s(p1,p3)**2*nDp1*
     &    nDp2 + 4.D0/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp3 + 4.D0/(s(p2,p3)
     &    )*s(p1,p3)**2*nDp2**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * ( 4.D0/(s(p2,p3))*s(p1,p3
     &    )*s(p1,p4)*nDp1*nDp2 + 4.D0/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp2**2 - 16.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 8.D0
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 14.D0/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp1**2 + 4.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2*nDp3 + 4.D0/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 - 6.D0
     &    /(s(p2,p3))*s(p1,p4)**2*nDp1*nDp2 - 4.D0/(s(p2,p3))*s(p1,p4)
     &    **2*nDp2*nDp3 + 2.D0/(s(p2,p3))*s(p1,p4)**2*nDp2**2 + 6.D0/(
     &    s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p2,p3))*s(p1,
     &    p4)*s(p2,p4)*nDp1**2 + 8.D0/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2
     &    *nDp3 + 4.D0/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp2 + 6.D0/(s(p2,p3
     &    ))*s(p2,p4)**2*nDp1*nDp3 + 12.D0/(s(p2,p3))*s(p2,p4)**2*
     &    nDp1**2 + 2.D0/(s(p2,p3))*s(p2,p4)**2*nDp3**2 - 2.D0/(s(p2,p3
     &    ))/(s(p2,p3))*s(p1,p2)**3*nDp1*nDp3 - 6.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp2 - 6.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp3 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1**2 - 4.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 4.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p1,p4)*nDp1*nDp2 - 4.D0/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p2)**2*s(p1,p4)*nDp1*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)**2*s(p1,p4)*nDp1**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p4)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*s(p1,p4)*nDp3**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p2,p4)*nDp1*nDp2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p2,p4)*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)**2*s(p2,p4)*nDp1**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)**2*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p3)*s(p1,p4)*nDp1*nDp2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 6.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 6.D0/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1**2 - 4.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*nDp3
     &     - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,
     &    p4)*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2
     &    *nDp1*nDp2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2*
     &    nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)**2*
     &    nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*s(p2,
     &    p4)*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*
     &    s(p2,p4)*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p4)*s(p2,p4)*nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p2,p4)**2*nDp1*nDp2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp3 + 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 - 2.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)**2*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 2.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 2.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1**2 - 2.D0/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p4)**3*nDp2**2 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p4)**2*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p4)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)
     &    *s(p2,p4)**2*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*
     &    s(p2,p4)**2*nDp3**2 )
      c1234 = c1234 + s134**(-1)*s234**(-1) * (  - 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p2,p4)**3*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p2,p4)**3*nDp3**2 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*
     &    nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**3*nDp3**2 - 
     &    8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 8.
     &    D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp2**2 + 16.D0
     &    /(s(p3,p4))*s(p1,p2)**2*nDp1*nDp2 + 8.D0/(s(p3,p4))*s(p1,p2)
     &    **2*nDp1*nDp3 + 8.D0/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3 - 16.D0
     &    /(s(p3,p4))*s(p1,p2)**2*nDp3**2 + 8.D0/(s(p3,p4))/(s(p3,p4))*
     &    s(p1,p2)**3*nDp3**2 )
      c1234 = c1234 + s134**(-1) * (  - 12.D0*nDp1*nDp2 - 24.D0*nDp1*
     &    nDp3 - 16.D0*nDp1**2 - 16.D0*nDp2*nDp3 - 6.D0*nDp2**2 - 8.D0*
     &    nDp3**2 + 8.D0/(s(p1,p2))*s(p1,p3)*nDp1*nDp2 - 8.D0/(s(p1,p2)
     &    )*s(p1,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))*s(p1,p3)*nDp2*nDp3 + 8.
     &    D0/(s(p1,p2))*s(p1,p3)*nDp2**2 - 8.D0/(s(p1,p2))*s(p1,p4)*
     &    nDp1*nDp2 - 4.D0/(s(p1,p2))*s(p1,p4)*nDp2*nDp3 - 2.D0/(s(p1,
     &    p2))*s(p1,p4)*nDp2**2 - 4.D0/(s(p1,p2))*s(p2,p3)*nDp1*nDp2 - 
     &    16.D0/(s(p1,p2))*s(p2,p3)*nDp1*nDp3 - 12.D0/(s(p1,p2))*s(p2,
     &    p3)*nDp1**2 - 8.D0/(s(p1,p2))*s(p2,p3)*nDp2*nDp3 - 4.D0/(s(p1
     &    ,p2))*s(p2,p3)*nDp3**2 + 8.D0/(s(p1,p2))*s(p2,p4)*nDp1*nDp2
     &     + 4.D0/(s(p1,p2))*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))*s(p2,
     &    p4)*nDp1**2 + 2.D0/(s(p1,p2))*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1
     &    ,p2))/(s(p1,p4))*s(p1,p3)**2*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(
     &    p1,p4))*s(p1,p3)**2*nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p1,p3)**2*nDp2**2 - 20.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2
     &    ,p3)*nDp1*nDp2 )
      c1234 = c1234 + s134**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1
     &    ,p3)*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)
     &    *s(p2,p3)*nDp1**2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2
     &    ,p3)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*
     &    nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1
     &    *nDp3 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1**2
     &     + 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 8.
     &    D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 + 4.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 + 16.D0/(s(p1,p2
     &    ))/(s(p1,p4))*s(p2,p3)**2*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,
     &    p4))*s(p2,p3)**2*nDp1*nDp3 + 18.D0/(s(p1,p2))/(s(p1,p4))*s(p2
     &    ,p3)**2*nDp1**2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)**2*
     &    nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1
     &    *nDp2 - 18.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1*
     &    nDp3 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp1**2
     &     - 32.D0/(
     & s(p1,p2))/(s(p1,p4))*s(p2,p3)*s(p2,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2
     &    ))/(s(p1,p4))*s(p2,p4)**2*nDp1*nDp3 + 2.D0/(s(p1,p2))/(s(p1,
     &    p4))*s(p2,p4)**2*nDp1**2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,
     &    p4)**2*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1
     &    ,p3)**2*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2
     &    ,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p4
     &    ))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p2)
     &    )/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1**2 + 8.D0/(
     &    s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*
     &    nDp3 + 2.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*nDp1
     &    *nDp3 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp3**2 - 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p3)**3*
     &    nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p3)**
     &    2*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*
     &    s(p2,p3)**2*s(p2,p4)*nDp3**2 )
      c1234 = c1234 + s134**(-1) * (  - 8.D0/(s(p1,p2))/(s(p1,p4))/(s(
     &    p3,p4))*s(p2,p3)*s(p2,p4)**2*nDp1*nDp3 + 16.D0/(s(p1,p2))/(s(
     &    p1,p4))/(s(p3,p4))*s(p2,p3)*s(p2,p4)**2*nDp3**2 + 8.D0/(s(p1,
     &    p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**3*nDp3**2 - 8.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)**2*nDp2**2 - 4.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p1,p4)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4)*nDp2*nDp3 + 12.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)
     &    **2*nDp2**2 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*
     &    nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2
     &    *nDp3 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp2 - 4.D
     &    0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p2
     &    ))/(s(p2,p3))*s(p2,p4)**2*nDp1**2 + 8.D0/(s(p1,p2))/(s(p2,p3)
     &    )*s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)
     &    **2*nDp3**2 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p2,p4)*nDp2*nDp3 )
      c1234 = c1234 + s134**(-1) * ( 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 + 4.D0/(s(p1,p2))
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp3 + 4.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3*nDp1**2 - 8.D0
     &    /(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 - 8.D0/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4)
     &    )*s(p1,p3)*s(p2,p3)*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p4)*nDp2*nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)
     &    **2*nDp1*nDp3 - 32.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2*nDp2*
     &    nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*s(p2,p4)*nDp1*
     &    nDp3 - 40.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*s(p2,p4)*nDp2*
     &    nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)**2*nDp1*nDp3 - 16.D
     &    0/(
     & s(p1,p2))/(s(p3,p4))*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(
     &    p3,p4))/(s(p3,p4))*s(p2,p3)**3*nDp3**2 + 24.D0/(s(p1,p2))/(s(
     &    p3,p4))/(s(p3,p4))*s(p2,p3)**2*s(p2,p4)*nDp3**2 + 24.D0/(s(p1
     &    ,p2))/(s(p3,p4))/(s(p3,p4))*s(p2,p3)*s(p2,p4)**2*nDp3**2 + 8.D
     &    0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p2,p4)**3*nDp3**2 - 12.D0
     &    /(s(p1,p4))*s(p1,p2)*nDp1*nDp2 - 16.D0/(s(p1,p4))*s(p1,p2)*
     &    nDp1*nDp3 - 12.D0/(s(p1,p4))*s(p1,p3)*nDp1*nDp2 - 12.D0/(s(p1
     &    ,p4))*s(p1,p3)*nDp1*nDp3 - 16.D0/(s(p1,p4))*s(p1,p3)*nDp1**2
     &     + 4.D0/(s(p1,p4))*s(p1,p3)*nDp2*nDp3 - 6.D0/(s(p1,p4))*s(p1,
     &    p3)*nDp2**2 + 4.D0/(s(p1,p4))*s(p2,p3)*nDp1*nDp2 - 6.D0/(s(p1
     &    ,p4))*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(p1,p4))*s(p2,p3)*nDp1**2
     &     - 8.D0/(s(p1,p4))*s(p2,p4)*nDp1*nDp2 - 12.D0/(s(p1,p4))*s(p2
     &    ,p4)*nDp1*nDp3 + 20.D0/(s(p1,p4))*s(p2,p4)*nDp1**2 - 14.D0/(
     &    s(p1,p4))*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p4))*s(p2,p4)*
     &    nDp3**2 + 16.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p2)**2*nDp1**2 + 
     &    24.D0/(
     & s(p1,p4))/(s(p1,p4))*s(p1,p2)*s(p2,p3)*nDp1**2 + 32.D0/(s(p1,p4)
     &    )/(s(p1,p4))*s(p1,p2)*s(p2,p4)*nDp1**2 + 16.D0/(s(p1,p4))/(s(
     &    p1,p4))*s(p2,p3)**2*nDp1**2 + 24.D0/(s(p1,p4))/(s(p1,p4))*s(
     &    p2,p3)*s(p2,p4)*nDp1**2 + 16.D0/(s(p1,p4))/(s(p1,p4))*s(p2,p4
     &    )**2*nDp1**2 + 8.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    **3*nDp1**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4)*nDp1**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))
     &    *s(p1,p2)*s(p2,p4)**2*nDp1**2 + 8.D0/(s(p1,p4))/(s(p1,p4))/(
     &    s(p2,p3))*s(p2,p4)**3*nDp1**2 - 16.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p2)**2*nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**
     &    2*nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp1**2
     &     - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp2 - 
     &    8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 - 12.D0
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1**2 - 28.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 - 16.D0/(s(p1,
     &    p4))/(
     & s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(p2,p3
     &    ))*s(p1,p2)*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p3)**2*nDp1*nDp2 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)*nDp1*nDp2 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4)*nDp1*nDp3 - 24.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)
     &    *nDp1**2 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp2
     &     - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp3 + 14.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1**2 - 2.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp1*nDp3 - 2.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp2 - 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1*
     &    nDp3 - 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1
     &    ,p3)*nDp1**2 - 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)
     &    **2*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p2)**2*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp1*nDp2 )
      c1234 = c1234 + s134**(-1) * (  - 12.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3
     &     - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(
     &    p2,p4)*nDp1**2 - 14.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p2,p4)**2*nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**3*nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**2*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2 - 2.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 - 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1*
     &    nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4
     &    )**2*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3)
     &    )*s(p1,p3)*s(p2,p4)**2*nDp3**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p2,p4)**3*nDp1*nDp3 )
      c1234 = c1234 + s134**(-1) * ( 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p2,p4)**3*nDp3**2 - 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)**3*nDp1*nDp3 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)*nDp1**2 - 8.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2*nDp1*nDp3 + 
     &    16.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)**2*
     &    nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**3*
     &    nDp1**2 - 40.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*nDp1*nDp3
     &     - 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*nDp1**2 - 48.D0/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp1*nDp3 - 56.D0/(s(p1,
     &    p4))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 - 40.D0/(s(p1,p4)
     &    )/(s(p3,p4))*s(p2,p3)**2*nDp1*nDp3 - 8.D0/(s(p1,p4))/(s(p3,p4
     &    ))*s(p2,p3)**2*nDp3**2 - 56.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)
     &    *s(p2,p4)*nDp1*nDp3 - 24.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**2
     &    *nDp1*nDp3 )
      c1234 = c1234 + s134**(-1) * ( 8.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4
     &    )**2*nDp1**2 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**2*nDp3**2
     &     - 16.D0/(s(p2,p3))*s(p1,p2)*nDp1*nDp2 - 16.D0/(s(p2,p3))*s(
     &    p1,p2)*nDp1*nDp3 - 10.D0/(s(p2,p3))*s(p1,p2)*nDp1**2 - 12.D0
     &    /(s(p2,p3))*s(p1,p2)*nDp2*nDp3 - 2.D0/(s(p2,p3))*s(p1,p2)*
     &    nDp2**2 - 6.D0/(s(p2,p3))*s(p1,p2)*nDp3**2 + 6.D0/(s(p2,p3))*
     &    s(p1,p3)*nDp1*nDp2 + 4.D0/(s(p2,p3))*s(p1,p3)*nDp2*nDp3 + 8.D0
     &    /(s(p2,p3))*s(p1,p3)*nDp2**2 - 10.D0/(s(p2,p3))*s(p1,p4)*nDp1
     &    *nDp2 - 8.D0/(s(p2,p3))*s(p1,p4)*nDp2*nDp3 - 4.D0/(s(p2,p3))*
     &    s(p1,p4)*nDp2**2 - 14.D0/(s(p2,p3))*s(p2,p4)*nDp1*nDp3 - 4.D0
     &    /(s(p2,p3))*s(p2,p4)*nDp1**2 - 6.D0/(s(p2,p3))*s(p2,p4)*nDp2*
     &    nDp3 - 2.D0/(s(p2,p3))*s(p2,p4)*nDp2**2 - 8.D0/(s(p2,p3))*s(
     &    p2,p4)*nDp3**2 - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp1*
     &    nDp2 - 10.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp1*nDp3 - 6.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp1**2 - 6.D0/(s(p2,p3))
     &    /(
     & s(p2,p3))*s(p1,p2)**2*nDp2*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)**2*nDp3**2 + 12.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1
     &    ,p3)*nDp1*nDp2 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)
     &    *nDp2*nDp3 + 10.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*
     &    nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp1*
     &    nDp2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*nDp2**2
     &     - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 + 4.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 + 2.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3**2 - 4.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)**2*nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p3)*s(p2,p4)*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**
     &    2*nDp2**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1
     &    *nDp2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2
     &     + 4.D0/(
     & s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp3 + 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p2,p4)**2*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p2,p4)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)**2*s(p1,p3)*nDp2*nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)**2*s(p1,p3)*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p2,
     &    p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp2*
     &    nDp3 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3
     &    )*s(p2,p4)*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)*s(p2,p4)**2*nDp1*nDp3 - 16.D0/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)**2*nDp1*nDp2 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*
     &    nDp1*nDp3 + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3
     &     + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**2*nDp3**2 - 2.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 - 12.D0/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 - 16.D0/(s(p2,p3)
     &    )/(
     & s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2**2 + 2.D0/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p2)*s(p1,p3)*nDp3**2 - 32.D0/(s(p2,p3))/(s(p3,p4))*s(p1
     &    ,p2)*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)
     &    *s(p2,p4)*nDp1*nDp3 + 10.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(
     &    p2,p4)*nDp2*nDp3 + 12.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p2,
     &    p4)*nDp3**2 + 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp2*
     &    nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp1*nDp3
     &     - 18.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 
     &    8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 - 4.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 - 16.D0/(s(p2,
     &    p3))/(s(p3,p4))*s(p2,p4)**2*nDp1*nDp2 - 14.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p2,p4)**2*nDp1*nDp3 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(
     &    p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p3,p4))*s(p1,p2)*nDp2*nDp3 + 8.D
     &    0/(s(p3,p4))*s(p1,p3)*nDp1*nDp3 - 16.D0/(s(p3,p4))*s(p1,p3)*
     &    nDp2*nDp3 - 8.D0/(s(p3,p4))*s(p1,p3)*nDp2**2 + 16.D0/(s(p3,p4
     &    ))*s(p2,p3)*nDp1*nDp3 )
      c1234 = c1234 + s134**(-1) * (  - 8.D0/(s(p3,p4))*s(p2,p3)*nDp2*
     &    nDp3 + 16.D0/(s(p3,p4))*s(p2,p3)*nDp3**2 - 16.D0/(s(p3,p4))*
     &    s(p2,p4)*nDp1*nDp2 - 16.D0/(s(p3,p4))*s(p2,p4)*nDp1*nDp3 - 8.D
     &    0/(s(p3,p4))*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p3,p4))*s(p2,p4)*
     &    nDp3**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)**2*nDp3**2 + 
     &    24.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp3**2 + 24.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2 + 16.D0/(s(
     &    p3,p4))/(s(p3,p4))*s(p2,p3)**2*nDp3**2 + 32.D0/(s(p3,p4))/(s(
     &    p3,p4))*s(p2,p3)*s(p2,p4)*nDp3**2 + 16.D0/(s(p3,p4))/(s(p3,p4
     &    ))*s(p2,p4)**2*nDp3**2 )
      c1234 = c1234 + s234**(-1) * ( 14.D0*nDp1*nDp2 + 24.D0*nDp1*nDp3
     &     + 44.D0*nDp1**2 - 14.D0*nDp2*nDp3 + 16.D0*nDp2**2 + 8.D0*
     &    nDp3**2 + 30.D0/(s(p1,p2))*s(p1,p3)*nDp1*nDp2 + 16.D0/(s(p1,
     &    p2))*s(p1,p3)*nDp1*nDp3 + 24.D0/(s(p1,p2))*s(p1,p3)*nDp1**2
     &     + 4.D0/(s(p1,p2))*s(p1,p3)*nDp2*nDp3 + 6.D0/(s(p1,p2))*s(p1,
     &    p3)*nDp2**2 + 4.D0/(s(p1,p2))*s(p1,p3)*nDp3**2 + 26.D0/(s(p1,
     &    p2))*s(p1,p4)*nDp1*nDp2 + 2.D0/(s(p1,p2))*s(p1,p4)*nDp1*nDp3
     &     + 26.D0/(s(p1,p2))*s(p1,p4)*nDp1**2 - 16.D0/(s(p1,p2))*s(p1,
     &    p4)*nDp2*nDp3 - 6.D0/(s(p1,p2))*s(p1,p4)*nDp2**2 - 14.D0/(s(
     &    p1,p2))*s(p1,p4)*nDp3**2 - 4.D0/(s(p1,p2))*s(p2,p3)*nDp1*nDp2
     &     - 10.D0/(s(p1,p2))*s(p2,p3)*nDp1*nDp3 - 8.D0/(s(p1,p2))*s(p2
     &    ,p3)*nDp1**2 + 4.D0/(s(p1,p2))*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(
     &    p1,p2))*s(p2,p3)*nDp2**2 + 4.D0/(s(p1,p2))*s(p2,p3)*nDp3**2
     &     + 4.D0/(s(p1,p2))*s(p2,p4)*nDp1*nDp2 - 12.D0/(s(p1,p2))*s(p2
     &    ,p4)*nDp1**2 + 10.D0/(s(p1,p2))*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(
     &    p1,p2))*s(p2,p4)*nDp2**2 )
      c1234 = c1234 + s234**(-1) * ( 4.D0/(s(p1,p2))*s(p2,p4)*nDp3**2
     &     - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*nDp1*nDp3 - 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p3)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))
     &    /(s(p1,p2))*s(p1,p3)**2*nDp3**2 + 16.D0/(s(p1,p2))/(s(p1,p2))
     &    *s(p1,p3)*s(p1,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p3)*s(p1,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,
     &    p3)*s(p1,p4)*nDp2*nDp3 + 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)
     &    *s(p1,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,
     &    p3)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*
     &    nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p3)*
     &    nDp2**2 - 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*
     &    nDp2 - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1*nDp3
     &     - 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp1**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p3)*s(p2,p4)*nDp2**2 + 20.D0/(s(p1,p2
     &    ))/(
     & s(p1,p2))*s(p1,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(
     &    p1,p4)**2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*
     &    nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)**2*nDp2**2 - 
     &    12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(
     &    p1,p2))/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp1**2 - 4.D0/(s(p1,p2)
     &    )/(s(p1,p2))*s(p1,p4)*s(p2,p3)*nDp2**2 - 4.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p1,
     &    p2))*s(p1,p4)*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*
     &    s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p1
     &    ,p4)*s(p2,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p3)**
     &    2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp1
     &    *nDp2 + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p3)*s(p2,p4)*nDp1**2
     &     + 4.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p4)**2*nDp1*nDp2 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p2,p4)**2*nDp1*nDp3 + 4.D0/(s(p1,p2))
     &    /(
     & s(p1,p2))*s(p2,p4)**2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2
     &    ,p3))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp2**2 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp1*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**3*nDp2*nDp3 - 4.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp1*
     &    nDp2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*s(p2
     &    ,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)
     &    **2*s(p1,p4)*nDp3**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)**2*s(p2,p3)*nDp3**2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp3 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp1**2 + 
     &    4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1
     &    ,p4)**2*nDp3**2 )
      c1234 = c1234 + s234**(-1) * (  - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp1*nDp3 + 8.D0/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*s(p2,p3)*nDp2*nDp3
     &     + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p2,p3)**2
     &    *nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**
     &    3*nDp2**2 + 16.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**
     &    2*s(p2,p3)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p4)**2*s(p2,p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(
     &    s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp1**2 + 8.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp2*nDp3 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*s(p2,p3)*nDp3**2 - 
     &    8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)**2*
     &    nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(
     &    p2,p3)**2*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(
     &    p2,p3)**3*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*
     &    nDp1*nDp2 )
      c1234 = c1234 + s234**(-1) * (  - 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1
     &    ,p3)**2*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)**2*
     &    nDp2**2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp1*
     &    nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3
     &     + 4.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p3)*nDp1**2 - 4.D0
     &    /(s(p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 - 4.D0/(s(
     &    p1,p2))/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp1**2 - 2.D0/(s(p1,p2)
     &    )/(s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 - 2.D0/(s(p1,p2))/(s(p1,
     &    p4))*s(p2,p3)**2*nDp1**2 + 2.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3
     &    )*s(p2,p4)*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)**2
     &    *nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)**2*nDp1**2 - 2.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(
     &    p2,p4)**3*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*
     &    s(p2,p4)**3*nDp1**2 - 6.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*
     &    nDp1*nDp2 )
      c1234 = c1234 + s234**(-1) * (  - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1
     &    ,p3)**2*nDp1*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*
     &    nDp1**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*nDp2*nDp3 - 
     &    8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)**2*nDp2**2 - 6.D0/(s(p1,
     &    p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 - 2.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)*nDp1**2 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)
     &    *s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp1*
     &    nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp3**2 - 8.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp3 )
      c1234 = c1234 + s234**(-1) * (  - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1
     &    ,p4)*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*
     &    s(p2,p4)*nDp2*nDp3 + 6.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*
     &    nDp1*nDp2 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp3
     &     - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)**2*nDp1**2 - 2.D0/(s(
     &    p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp1*nDp2 - 2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp2**2 - 4.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp1*
     &    nDp2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p1
     &    ,p4)*nDp1*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p3)**2*s(p1,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)**2*s(p1,p4)*nDp2**2 + 4.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp2 + 4.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp2**2
     &     - 2.D0/(
     & s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2*nDp1*nDp3
     &     - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)**2
     &    *nDp2*nDp3 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*
     &    s(p1,p4)**2*nDp3**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*nDp1*nDp3 + 4.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*s(p2,p4)*
     &    nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(
     &    p1,p4)*s(p2,p4)*nDp2**2 - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p3)*s(p2,p4)**2*nDp1*nDp2 - 2.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 - 2.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p4)**3*nDp3**2 + 4.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*s(p2,p4)*nDp2*nDp3 - 2.D0/(
     &    s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*s(p2,p4)**2*nDp2**2
     &     + 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**3*nDp2*
     &    nDp3 )
      c1234 = c1234 + s234**(-1) * ( 8.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p3)**3*nDp3**2 + 16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p3)**2*s(p1,p4)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p3)**2*s(p1,p4)*nDp3**2 + 8.D0/(s(p1,p2)
     &    )/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp2*nDp3 + 8.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)**2*
     &    nDp3**2 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3
     &     - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 + 16.D0/(
     &    s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 - 20.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 12.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1**2 - 16.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)*nDp2**2 - 12.D0/(s(p1,p2))/(s(p3,p4
     &    ))*s(p1,p3)*s(p1,p4)*nDp3**2 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p3)*nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p3)*nDp2*nDp3 )
      c1234 = c1234 + s234**(-1) * ( 4.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3
     &    )*s(p2,p3)*nDp3**2 - 20.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*
     &    nDp1*nDp3 - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2*nDp3
     &     - 8.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp3**2 + 8.D0/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 + 8.D0/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp3 + 8.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1**2 - 16.D0/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p4)*s(p2,p3)*nDp2*nDp3 - 8.D0/(s(p1,p2))/(s(p3,
     &    p4))*s(p1,p4)*s(p2,p3)*nDp3**2 - 12.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p2,p3)**2*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))
     &    *s(p1,p3)**3*nDp3**2 + 24.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))
     &    *s(p1,p3)**2*s(p1,p4)*nDp3**2 + 24.D0/(s(p1,p2))/(s(p3,p4))/(
     &    s(p3,p4))*s(p1,p3)*s(p1,p4)**2*nDp3**2 + 8.D0/(s(p1,p2))/(s(
     &    p3,p4))/(s(p3,p4))*s(p1,p4)**3*nDp3**2 + 22.D0/(s(p1,p4))*s(
     &    p1,p2)*nDp1*nDp2 + 34.D0/(s(p1,p4))*s(p1,p2)*nDp1*nDp3 + 28.D0
     &    /(
     & s(p1,p4))*s(p1,p2)*nDp1**2 + 4.D0/(s(p1,p4))*s(p1,p2)*nDp2*nDp3
     &     + 10.D0/(s(p1,p4))*s(p1,p2)*nDp2**2 + 22.D0/(s(p1,p4))*s(p1,
     &    p3)*nDp1*nDp2 + 40.D0/(s(p1,p4))*s(p1,p3)*nDp1*nDp3 + 38.D0/(
     &    s(p1,p4))*s(p1,p3)*nDp1**2 + 8.D0/(s(p1,p4))*s(p1,p3)*nDp3**2
     &     + 2.D0/(s(p1,p4))*s(p2,p3)*nDp1*nDp2 + 2.D0/(s(p1,p4))*s(p2,
     &    p3)*nDp1*nDp3 - 10.D0/(s(p1,p4))*s(p2,p3)*nDp1**2 - 14.D0/(s(
     &    p1,p4))*s(p2,p4)*nDp1*nDp2 - 4.D0/(s(p1,p4))*s(p2,p4)*nDp1*
     &    nDp3 - 24.D0/(s(p1,p4))*s(p2,p4)*nDp1**2 - 2.D0/(s(p1,p4))*s(
     &    p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p4))*s(p2,p4)*nDp3**2 - 8.D0/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p2)**2*nDp1*nDp2 - 6.D0/(s(p1,p4))
     &    /(s(p2,p3))*s(p1,p2)**2*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p2)**2*nDp1**2 - 12.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*
     &    s(p1,p3)*nDp1*nDp2 - 10.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p3)*nDp1*nDp3 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p3)*nDp1**2 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*
     &    nDp1*nDp2 )
      c1234 = c1234 + s234**(-1) * (  - 16.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p2)*s(p2,p4)*nDp1**2 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2
     &    )*s(p2,p4)*nDp2*nDp3 + 16.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*
     &    s(p2,p4)*nDp2**2 - 6.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*
     &    nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*nDp1*nDp3
     &     + 2.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*nDp1**2 + 16.D0/(s(
     &    p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 4.D0/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 24.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 - 8.D0/(s(p1,p4))/(s(p2,p3)
     &    )*s(p1,p3)*s(p2,p4)*nDp3**2 - 14.D0/(s(p1,p4))/(s(p2,p3))*s(
     &    p2,p4)**2*nDp1*nDp2 - 18.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2
     &    *nDp1*nDp3 - 32.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1**2
     &     + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**3*nDp1*
     &    nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p1
     &    ,p3)*nDp1*nDp2 )
      c1234 = c1234 + s234**(-1) * ( 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p2)**2*s(p1,p3)*nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)**2*s(p1,p3)*nDp1**2 + 6.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*s(p2,p4)*nDp1*nDp3 - 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)**2*nDp1*
     &    nDp2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3
     &    )**2*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)**2*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 8.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p3)*s(p2,p4)*
     &    nDp1**2 + 14.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p2,p4)**2*nDp1*nDp2 + 20.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p2)*s(p2,p4)**2*nDp1*nDp3 + 6.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp1**2 + 16.D0/(s(p1,p4))/(s(
     &    p2,p3))/(
     & s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(p1,p4))/(s(p2
     &    ,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp2**2 + 8.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)**2*nDp3**2 - 2.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**3*nDp1*nDp2 + 6.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*s(p2,p4)*nDp1*
     &    nDp2 + 12.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,
     &    p4)**2*nDp1*nDp2 + 18.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p3)*s(p2,p4)**2*nDp1*nDp3 + 10.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp1**2 + 16.D0/(s(p1,p4))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2*nDp3 + 8.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*nDp2**2 + 
     &    8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)**2*
     &    nDp3**2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**3*
     &    nDp1*nDp2 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**3
     &    *nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p2)**
     &    2*s(p1,p3)*nDp1*nDp3 )
      c1234 = c1234 + s234**(-1) * ( 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)*s(p1,p3)**2*nDp1*nDp3 - 12.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p2)**2*nDp1*nDp3 + 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p2)**2*nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)**2*
     &    nDp3**2 - 20.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1*
     &    nDp3 + 4.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp1**2
     &     + 2.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp2*nDp3 + 4.
     &    D0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p1,p3)*nDp3**2 + 12.D0/(
     &    s(p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp1*nDp3 + 16.D0/(s(
     &    p1,p4))/(s(p3,p4))*s(p1,p2)*s(p2,p3)*nDp1**2 - 8.D0/(s(p1,p4)
     &    )/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 + 12.D0/(s(p1,p4))/(s(p3,
     &    p4))*s(p1,p3)*s(p2,p3)*nDp1*nDp3 + 8.D0/(s(p1,p4))/(s(p3,p4))
     &    *s(p1,p3)*s(p2,p3)*nDp1**2 + 8.D0/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p3)*s(p2,p3)*nDp3**2 + 12.D0/(s(p2,p3))*s(p1,p2)*nDp1*nDp2 - 
     &    2.D0/(s(p2,p3))*s(p1,p2)*nDp1*nDp3 + 8.D0/(s(p2,p3))*s(p1,p2)
     &    *nDp1**2 )
      c1234 = c1234 + s234**(-1) * ( 16.D0/(s(p2,p3))*s(p1,p2)*nDp2*
     &    nDp3 - 4.D0/(s(p2,p3))*s(p1,p2)*nDp3**2 - 18.D0/(s(p2,p3))*s(
     &    p1,p3)*nDp1*nDp2 + 8.D0/(s(p2,p3))*s(p1,p3)*nDp1*nDp3 + 4.D0
     &    /(s(p2,p3))*s(p1,p3)*nDp1**2 + 16.D0/(s(p2,p3))*s(p1,p3)*nDp2
     &    *nDp3 - 8.D0/(s(p2,p3))*s(p1,p3)*nDp2**2 + 8.D0/(s(p2,p3))*s(
     &    p1,p3)*nDp3**2 + 6.D0/(s(p2,p3))*s(p1,p4)*nDp1*nDp2 + 10.D0/(
     &    s(p2,p3))*s(p1,p4)*nDp1*nDp3 + 20.D0/(s(p2,p3))*s(p1,p4)*nDp2
     &    *nDp3 - 16.D0/(s(p2,p3))*s(p1,p4)*nDp2**2 + 36.D0/(s(p2,p3))*
     &    s(p2,p4)*nDp1*nDp2 - 20.D0/(s(p2,p3))*s(p2,p4)*nDp1*nDp3 + 2.D
     &    0/(s(p2,p3))*s(p2,p4)*nDp1**2 + 20.D0/(s(p2,p3))*s(p2,p4)*
     &    nDp2*nDp3 + 32.D0/(s(p2,p3))*s(p2,p4)*nDp2**2 - 12.D0/(s(p2,
     &    p3))*s(p2,p4)*nDp3**2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**
     &    2*nDp1*nDp2 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp1*
     &    nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp1**2 + 4.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p1,p2)**2*nDp2*nDp3 + 2.D0/(s(p2,p3)
     &    )/(
     & s(p2,p3))*s(p1,p2)**2*nDp3**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,
     &    p2)*s(p1,p3)*nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(
     &    p1,p4)*nDp1*nDp2 - 12.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,
     &    p4)*nDp2*nDp3 - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p1,p4)*
     &    nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*
     &    nDp2 + 18.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*
     &    nDp3 + 20.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*
     &    nDp3 + 20.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp3**2
     &     - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp1*nDp2 - 6.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp1*nDp3 - 4.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)**2*nDp1**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p1,p3)**2*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(
     &    p1,p4)*nDp1*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,
     &    p4)*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp2**2 - 6.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*
     &    nDp2 )
      c1234 = c1234 + s234**(-1) * ( 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3
     &    )*s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(
     &    p2,p4)*nDp1**2 - 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4
     &    )*nDp2*nDp3 - 12.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*
     &    nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*nDp2**2 - 2.D
     &    0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)**2*nDp3**2 + 2.D0/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp1*nDp3 - 8.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 - 16.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p4)*s(p2,p4)*nDp2**2 + 14.D0/(s(p2,p3))/(s(p2,p3))*
     &    s(p2,p4)**2*nDp1*nDp2 + 14.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)
     &    **2*nDp1*nDp3 + 32.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp2*
     &    nDp3 + 14.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp2**2 + 18.D0
     &    /(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp3**2 + 24.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p2)**2*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p2)**2*nDp2**2 + 14.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)
     &    **2*nDp3**2 )
      c1234 = c1234 + s234**(-1) * ( 4.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2
     &    )*s(p1,p3)*nDp1*nDp3 + 26.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)*nDp2*nDp3 + 22.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(
     &    p1,p3)*nDp3**2 + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4
     &    )*nDp2*nDp3 + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*
     &    nDp2**2 + 14.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*s(p1,p4)*
     &    nDp3**2 + 2.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 + 
     &    18.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 + 16.D0/(s(
     &    p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp3**2 + 2.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 34.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p3)*s(p1,p4)*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p3)*s(p1,p4)*nDp2**2 + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1
     &    ,p3)*s(p1,p4)*nDp3**2 + 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)
     &    **2*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)**2*
     &    nDp2**2 + 32.D0/(s(p3,p4))*s(p1,p2)*nDp1*nDp2 - 30.D0/(s(p3,
     &    p4))*s(p1,p2)*nDp1*nDp3 )
      c1234 = c1234 + s234**(-1) * ( 20.D0/(s(p3,p4))*s(p1,p2)*nDp2*
     &    nDp3 - 8.D0/(s(p3,p4))*s(p1,p2)*nDp3**2 + 24.D0/(s(p3,p4))*s(
     &    p1,p3)*nDp1*nDp2 - 18.D0/(s(p3,p4))*s(p1,p3)*nDp1*nDp3 + 12.D0
     &    /(s(p3,p4))*s(p1,p3)*nDp1**2 + 10.D0/(s(p3,p4))*s(p1,p3)*nDp2
     &    *nDp3 + 4.D0/(s(p3,p4))*s(p1,p3)*nDp3**2 + 16.D0/(s(p3,p4))*
     &    s(p1,p4)*nDp1*nDp2 - 20.D0/(s(p3,p4))*s(p1,p4)*nDp1*nDp3 + 16.
     &    D0/(s(p3,p4))*s(p1,p4)*nDp2*nDp3 + 8.D0/(s(p3,p4))*s(p1,p4)*
     &    nDp3**2 + 14.D0/(s(p3,p4))*s(p2,p3)*nDp1*nDp3 + 12.D0/(s(p3,
     &    p4))*s(p2,p3)*nDp1**2 - 6.D0/(s(p3,p4))*s(p2,p3)*nDp2*nDp3 + 
     &    4.D0/(s(p3,p4))*s(p2,p3)*nDp3**2 + 16.D0/(s(p3,p4))/(s(p3,p4)
     &    )*s(p1,p2)**2*nDp3**2 + 24.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*
     &    s(p1,p3)*nDp3**2 + 24.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p2)*s(p1,
     &    p4)*nDp3**2 + 16.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)**2*nDp3**2
     &     + 32.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp3**2 + 16.
     &    D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**2*nDp3**2 )
      c1234 = c1234 + 12.D0/(s(p1,p2))*nDp1*nDp2 - 42.D0/(s(p1,p2))*
     &    nDp1*nDp3 - 8.D0/(s(p1,p2))*nDp1**2 - 20.D0/(s(p1,p2))*nDp2*
     &    nDp3 - 12.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p3)*nDp1*nDp2 + 16.D0
     &    /(s(p1,p2))/(s(p1,p2))*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(
     &    s(p1,p2))*s(p1,p3)*nDp2**2 - 52.D0/(s(p1,p2))/(s(p1,p2))*s(p1
     &    ,p4)*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*nDp1*
     &    nDp3 - 16.D0/(s(p1,p2))/(s(p1,p2))*s(p1,p4)*nDp1**2 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))*s(p1,p4)*nDp2**2 + 16.D0/(s(p1,p2))/(s(
     &    p1,p2))*s(p2,p3)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p4
     &    )*nDp1*nDp2 + 32.D0/(s(p1,p2))/(s(p1,p2))*s(p2,p4)*nDp1**2 + 
     &    16.D0/(s(p1,p2))/(s(p1,p2))*s(p3,p4)*nDp1**2 + 4.D0/(s(p1,p2)
     &    )/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp2**2 + 4.D0/(s(
     &    p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp1*nDp2 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p2,p3))*s(p1,p4)**2*nDp2**2 + 4.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)**2*nDp3**2 - 16.D0/(
     &    s(p1,p2))/(
     & s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2
     &    ))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 - 8.D0/(
     &    s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1**2 - 
     &    24.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2
     &    *nDp3 - 16.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)*nDp3**2 - 8.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    s(p2,p3)*nDp1*nDp3 + 24.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p2))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p4)*nDp1**2 - 8.D0/(s(p1,p2))/(s(p1,p2)
     &    )/(s(p3,p4))*s(p1,p4)**2*nDp1*nDp2 + 16.D0/(s(p1,p2))/(s(p1,
     &    p2))/(s(p3,p4))*s(p1,p4)**2*nDp2*nDp3 + 20.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)**2*nDp2**2 - 8.D0/(s(p1,p2))/(s(
     &    p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp2 - 16.D0/(s(p1,
     &    p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1*nDp3 - 12.D0
     &    /(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp1**2
     &     - 40.D0/(
     & s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp1*nDp2 - 16.
     &    D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp1*
     &    nDp3 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*s(p2,p4
     &    )*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p3)**2
     &    *nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*s(
     &    p2,p4)*nDp1**2 + 20.D0/(s(p1,p2))/(s(p1,p2))/(s(p3,p4))*s(p2,
     &    p4)**2*nDp1**2 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*nDp1*
     &    nDp2 - 24.D0/(s(p1,p2))/(s(p1,p4))*s(p1,p3)*nDp1*nDp3 + 16.D0
     &    /(s(p1,p2))/(s(p1,p4))*s(p1,p3)*nDp1**2 - 16.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p1,p3)*nDp2*nDp3 + 32.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p2,p3)*nDp1*nDp2 - 24.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*nDp1*
     &    nDp3 + 32.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p3)*nDp1**2 - 32.D0/(
     &    s(p1,p2))/(s(p1,p4))*s(p2,p3)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p2,p3)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(p2,
     &    p4)*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)*nDp1*
     &    nDp3
      c1234 = c1234 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)*nDp1**2 - 32.
     &    D0/(s(p1,p2))/(s(p1,p4))*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p1,p2))
     &    /(s(p1,p4))*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p2,p4)*nDp3**2 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(p3,p4)*nDp1*
     &    nDp2 - 8.D0/(s(p1,p2))/(s(p1,p4))*s(p3,p4)*nDp1*nDp3 + 16.D0
     &    /(s(p1,p2))/(s(p1,p4))*s(p3,p4)*nDp1**2 - 16.D0/(s(p1,p2))/(
     &    s(p1,p4))*s(p3,p4)*nDp2*nDp3 + 16.D0/(s(p1,p2))/(s(p1,p4))*s(
     &    p3,p4)*nDp2**2 + 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,
     &    p3)**2*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(
     &    p1,p3)**2*nDp1*nDp3 + 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)**2*nDp1**2 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*
     &    s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1**2 - 4.D0/(s(p1,p2))/(
     &    s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 + 16.D0/(s(p1,
     &    p2))/(
     & s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1*nDp2 - 8.D0/(s(p1,p2
     &    ))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1*nDp3 + 16.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1**2
     &     - 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1*
     &    nDp3 - 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp2
     &    *nDp3 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,
     &    p4)*nDp1*nDp2 + 4.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))*s(p2,p4
     &    )*s(p3,p4)*nDp2**2 - 8.D0/(s(p1,p2))/(s(p1,p4))/(s(p2,p3))/(
     &    s(p3,p4))*s(p1,p3)**3*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p1,p4))
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*s(p2,p4)*nDp1*nDp3 - 8.D0
     &    /(s(p1,p2))/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4
     &    )**2*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p1,
     &    p3)**2*nDp1*nDp3 - 24.D0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(
     &    p1,p3)*s(p2,p3)*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p1,p4))/(s(p3
     &    ,p4))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p2))/(s(p1,p4)
     &    )/(
     & s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp1**2 + 8.D0/(s(p1,p2))/(s(p1,p4))
     &    /(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 - 16.D0/(s(p1,p2))/(s(
     &    p1,p4))/(s(p3,p4))*s(p2,p3)**2*nDp1*nDp3 - 16.D0/(s(p1,p2))/(
     &    s(p1,p4))/(s(p3,p4))*s(p2,p3)*s(p2,p4)*nDp1*nDp3 + 16.D0/(s(
     &    p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p3)*s(p2,p4)*nDp3**2 + 16.D
     &    0/(s(p1,p2))/(s(p1,p4))/(s(p3,p4))*s(p2,p4)**2*nDp3**2 - 2.D0
     &    /(s(p1,p2))/(s(p2,p3))*s(p1,p3)*nDp1*nDp2 - 28.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p3)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))*
     &    s(p1,p3)*nDp1**2 - 4.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*nDp2*
     &    nDp3 - 6.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p3)*nDp2**2 + 8.D0/(s(
     &    p1,p2))/(s(p2,p3))*s(p1,p3)*nDp3**2 + 4.D0/(s(p1,p2))/(s(p2,
     &    p3))*s(p1,p4)*nDp1*nDp2 + 8.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)
     &    *nDp1*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*nDp1**2 - 4.D
     &    0/(s(p1,p2))/(s(p2,p3))*s(p1,p4)*nDp2*nDp3 - 10.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p1,p4)*nDp2**2 + 6.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p2,p4)*nDp1*nDp2
      c1234 = c1234 + 2.D0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*nDp1**2 + 12.D
     &    0/(s(p1,p2))/(s(p2,p3))*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p2))
     &    /(s(p2,p3))*s(p2,p4)*nDp2**2 + 6.D0/(s(p1,p2))/(s(p2,p3))*s(
     &    p3,p4)*nDp1*nDp2 - 2.D0/(s(p1,p2))/(s(p2,p3))*s(p3,p4)*
     &    nDp1**2 - 8.D0/(s(p1,p2))/(s(p2,p3))*s(p3,p4)*nDp2**2 - 4.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp1*nDp2 - 4.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)**2*nDp2**2 - 2.D0
     &    /(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*nDp1*nDp2
     &     - 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p1,p4)*
     &    nDp1*nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(
     &    p1,p4)*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p3)*s(p1,p4)*nDp2**2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(p2,p3))
     &    *s(p1,p3)*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 - 2.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1*nDp2 - 2.D0/(s(p1,p2))/(
     &    s(p2,p3))/(
     & s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2**2 - 4.D0/(s(p1,p2))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p4)**2*nDp2*nDp3 + 2.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p4)*s(p2,p4)*nDp2**2 - 2.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p2,p3))*s(p1,p4)*s(p3,p4)*nDp2**2 - 16.D0/(s(p1,p2
     &    ))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 + 16.D0/(s(p1,
     &    p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp2*nDp3 + 16.D0/(s(
     &    p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp3**2 - 8.D0/(s(
     &    p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp1*nDp3 + 
     &    16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp2
     &    *nDp3 + 16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p1,
     &    p4)*nDp3**2 - 16.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)
     &    *s(p2,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 4.D0/(s(p1,p2))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p3)*s(p2,p4)*nDp2**2 + 8.D0/(s(p1,p2))/(s(p2,p3)
     &    )/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 + 4.D0/(s(p1,p2))/(s(
     &    p2,p3))/(
     & s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2*nDp3 + 4.D0/(s(p1,p2))/(s(p2,p3
     &    ))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*nDp2**2 - 8.D0/(s(p1,p2))/(s(
     &    p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp1*nDp2 - 4.D0/(s(p1,p2))/(
     &    s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp1*nDp3 - 16.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p3)*nDp1*nDp2 - 60.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p3)*nDp1*nDp3 - 16.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*
     &    nDp1**2 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 + 12.
     &    D0/(s(p1,p2))/(s(p3,p4))*s(p1,p3)*nDp3**2 - 20.D0/(s(p1,p2))
     &    /(s(p3,p4))*s(p1,p4)*nDp1*nDp3 + 4.D0/(s(p1,p2))/(s(p3,p4))*
     &    s(p1,p4)*nDp2*nDp3 + 40.D0/(s(p1,p2))/(s(p3,p4))*s(p1,p4)*
     &    nDp3**2 - 36.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*nDp1*nDp3 - 8.D
     &    0/(s(p1,p2))/(s(p3,p4))*s(p2,p3)*nDp1**2 - 24.D0/(s(p1,p2))/(
     &    s(p3,p4))*s(p2,p3)*nDp2*nDp3 + 8.D0/(s(p1,p2))/(s(p3,p4))*s(
     &    p2,p3)*nDp3**2 - 52.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)*nDp1*
     &    nDp3 - 24.D0/(s(p1,p2))/(s(p3,p4))*s(p2,p4)*nDp2*nDp3 + 16.D0
     &    /(
     & s(p1,p2))/(s(p3,p4))*s(p2,p4)*nDp3**2 + 16.D0/(s(p1,p2))/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)**2*nDp3**2 + 32.D0/(s(p1,p2))/(s(p3,
     &    p4))/(s(p3,p4))*s(p1,p3)*s(p1,p4)*nDp3**2 + 24.D0/(s(p1,p2))
     &    /(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p3)*nDp3**2 + 24.D0/(s(
     &    p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 + 16.D
     &    0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)**2*nDp3**2 + 24.D0
     &    /(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p3)*nDp3**2
     &     + 24.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*s(p2,p4)*
     &    nDp3**2 + 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p2,p3)**2*
     &    nDp3**2 + 32.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p2,p3)*s(
     &    p2,p4)*nDp3**2 + 16.D0/(s(p1,p2))/(s(p3,p4))/(s(p3,p4))*s(p2,
     &    p4)**2*nDp3**2 + 10.D0/(s(p1,p4))*nDp1*nDp2 - 100.D0/(s(p1,p4
     &    ))*nDp1*nDp3 + 50.D0/(s(p1,p4))*nDp1**2 + 8.D0/(s(p1,p4))*
     &    nDp2**2 - 8.D0/(s(p1,p4))*nDp3**2 + 48.D0/(s(p1,p4))/(s(p1,p4
     &    ))*s(p1,p2)*nDp1**2 + 48.D0/(s(p1,p4))/(s(p1,p4))*s(p1,p3)*
     &    nDp1**2
      c1234 = c1234 + 48.D0/(s(p1,p4))/(s(p1,p4))*s(p2,p3)*nDp1**2 + 48.
     &    D0/(s(p1,p4))/(s(p1,p4))*s(p2,p4)*nDp1**2 + 48.D0/(s(p1,p4))
     &    /(s(p1,p4))*s(p3,p4)*nDp1**2 + 16.D0/(s(p1,p4))/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)**2*nDp1**2 + 24.D0/(s(p1,p4))/(s(p1,p4))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1**2 + 32.D0/(s(p1,p4))/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1**2 + 24.D0/(s(p1,p4))
     &    /(s(p1,p4))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp1**2 + 16.D0/(s(
     &    p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)**2*nDp1**2 + 24.D0/(s(
     &    p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp1**2 + 32.D
     &    0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1**2
     &     + 16.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)**2*nDp1**2
     &     + 24.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*
     &    nDp1**2 + 16.D0/(s(p1,p4))/(s(p1,p4))/(s(p2,p3))*s(p3,p4)**2*
     &    nDp1**2 - 34.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*nDp1*nDp2 - 46.
     &    D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)*nDp1*nDp3 + 18.D0/(s(p1,p4)
     &    )/(
     & s(p2,p3))*s(p1,p2)*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p2)
     &    *nDp2**2 - 26.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*nDp1*nDp2 - 
     &    52.D0/(s(p1,p4))/(s(p2,p3))*s(p1,p3)*nDp1*nDp3 + 16.D0/(s(p1,
     &    p4))/(s(p2,p3))*s(p1,p3)*nDp1**2 - 8.D0/(s(p1,p4))/(s(p2,p3))
     &    *s(p2,p4)*nDp1*nDp2 - 16.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*
     &    nDp1*nDp3 + 42.D0/(s(p1,p4))/(s(p2,p3))*s(p2,p4)*nDp1**2 - 34.
     &    D0/(s(p1,p4))/(s(p2,p3))*s(p3,p4)*nDp1*nDp2 - 28.D0/(s(p1,p4)
     &    )/(s(p2,p3))*s(p3,p4)*nDp1*nDp3 + 6.D0/(s(p1,p4))/(s(p2,p3))*
     &    s(p3,p4)*nDp1**2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)**2*nDp1**2 - 12.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1
     &    ,p2)*s(p1,p3)*nDp1*nDp2 - 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p2)*s(p1,p3)*nDp1*nDp3 - 4.D0/(s(p1,p4))/(s(p2,p3))/(
     &    s(p2,p3))*s(p1,p2)*s(p1,p3)*nDp1**2 - 6.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp2 - 22.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 - 14.D0/(
     &    s(p1,p4))/(
     & s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp1**2 - 16.D0/(s(p1,p4)
     &    )/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2*nDp3 - 8.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p2,p4)*nDp2**2 + 
     &    22.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,p4)*nDp1
     &    *nDp2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*s(p3,
     &    p4)*nDp1*nDp3 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p2
     &    )*s(p3,p4)*nDp1**2 + 8.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p2)*s(p3,p4)*nDp2**2 - 6.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3
     &    ))*s(p1,p3)**2*nDp1*nDp2 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)**2*nDp2**2 - 10.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,
     &    p3))*s(p1,p3)*s(p2,p4)*nDp1*nDp2 - 8.D0/(s(p1,p4))/(s(p2,p3))
     &    /(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2*nDp3 - 12.D0/(s(p1,p4))/(
     &    s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p2,p4)*nDp2**2 - 6.D0/(s(p1,
     &    p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp1*nDp2 + 4.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*s(p3,p4)*nDp2**2
     &     - 2.D0/(
     & s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp2 + 16.D0/(
     &    s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp1*nDp3 - 8.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp2*nDp3 + 20.D
     &    0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)**2*nDp3**2 - 14.D0
     &    /(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*nDp1*nDp2
     &     - 40.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(p3,p4)*
     &    nDp2*nDp3 + 4.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*s(
     &    p3,p4)*nDp2**2 - 2.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(p3,
     &    p4)**2*nDp1*nDp2 + 20.D0/(s(p1,p4))/(s(p2,p3))/(s(p2,p3))*s(
     &    p3,p4)**2*nDp2**2 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(
     &    p1,p2)**2*nDp1*nDp3 - 24.D0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*
     &    s(p1,p2)*s(p1,p3)*nDp1*nDp3 - 16.D0/(s(p1,p4))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)*s(p2,p4)*nDp1*nDp3 + 16.D0/(s(p1,p4))/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*s(p2,p4)*nDp1**2 - 16.D0/(s(p1,p4))
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p3)**2*nDp1*nDp3 - 16.D0/(s(p1,p4
     &    ))/(
     & s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp1*nDp3 + 8.D0/(s(p1,p4
     &    ))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp1**2 + 8.D0/(s(
     &    p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*s(p2,p4)*nDp3**2 + 16.D
     &    0/(s(p1,p4))/(s(p2,p3))/(s(p3,p4))*s(p2,p4)**2*nDp1**2 - 112.D
     &    0/(s(p1,p4))/(s(p3,p4))*s(p1,p2)*nDp1*nDp3 - 16.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p1,p2)*nDp1**2 - 120.D0/(s(p1,p4))/(s(p3,p4))*
     &    s(p1,p3)*nDp1*nDp3 - 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*
     &    nDp1**2 - 16.D0/(s(p1,p4))/(s(p3,p4))*s(p1,p3)*nDp3**2 - 112.D
     &    0/(s(p1,p4))/(s(p3,p4))*s(p2,p3)*nDp1*nDp3 - 16.D0/(s(p1,p4))
     &    /(s(p3,p4))*s(p2,p3)*nDp3**2 - 96.D0/(s(p1,p4))/(s(p3,p4))*s(
     &    p2,p4)*nDp1*nDp3 - 38.D0/(s(p2,p3))*nDp1*nDp2 - 6.D0/(s(p2,p3
     &    ))*nDp1*nDp3 + 4.D0/(s(p2,p3))*nDp1**2 + 32.D0/(s(p2,p3))*
     &    nDp2*nDp3 - 14.D0/(s(p2,p3))*nDp2**2 + 12.D0/(s(p2,p3))*
     &    nDp3**2 + 12.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*nDp1*nDp2 - 24.
     &    D0/(s(p2,p3))/(s(p2,p3))*s(p1,p2)*nDp2*nDp3 - 8.D0/(s(p2,p3))
     &    /(
     & s(p2,p3))*s(p1,p2)*nDp2**2 - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)
     &    *nDp1*nDp2 - 8.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*nDp1*nDp3 - 
     &    4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p3)*nDp1**2 + 12.D0/(s(p2,p3)
     &    )/(s(p2,p3))*s(p1,p3)*nDp2**2 - 2.D0/(s(p2,p3))/(s(p2,p3))*s(
     &    p1,p4)*nDp1*nDp3 - 4.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*nDp2*
     &    nDp3 + 16.D0/(s(p2,p3))/(s(p2,p3))*s(p1,p4)*nDp2**2 - 18.D0/(
     &    s(p2,p3))/(s(p2,p3))*s(p2,p4)*nDp1*nDp2 + 2.D0/(s(p2,p3))/(s(
     &    p2,p3))*s(p2,p4)*nDp1*nDp3 - 56.D0/(s(p2,p3))/(s(p2,p3))*s(p2
     &    ,p4)*nDp2*nDp3 - 18.D0/(s(p2,p3))/(s(p2,p3))*s(p2,p4)*nDp2**2
     &     - 2.D0/(s(p2,p3))/(s(p2,p3))*s(p3,p4)*nDp1*nDp2 - 2.D0/(s(p2
     &    ,p3))/(s(p2,p3))*s(p3,p4)*nDp1*nDp3 + 34.D0/(s(p2,p3))/(s(p2,
     &    p3))*s(p3,p4)*nDp2**2 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p2)**2*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4)
     &    )*s(p1,p2)**2*nDp3**2 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p2)*s(p2,p4)*nDp2*nDp3 + 2.D0/(s(p2,p3))/(s(p2,p3))/(s(
     &    p3,p4))*s(p1,p2)*s(p2,p4)*nDp3**2
      c1234 = c1234 - 32.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*nDp1*nDp2 - 
     &    14.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*nDp1*nDp3 + 28.D0/(s(p2,
     &    p3))/(s(p3,p4))*s(p1,p2)*nDp2*nDp3 + 16.D0/(s(p2,p3))/(s(p3,
     &    p4))*s(p1,p2)*nDp2**2 + 30.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p2)*
     &    nDp3**2 - 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*nDp1*nDp2 - 32.
     &    D0/(s(p2,p3))/(s(p3,p4))*s(p1,p3)*nDp1*nDp3 + 12.D0/(s(p2,p3)
     &    )/(s(p3,p4))*s(p1,p3)*nDp2*nDp3 + 16.D0/(s(p2,p3))/(s(p3,p4))
     &    *s(p1,p3)*nDp3**2 - 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*nDp1
     &    *nDp2 - 16.D0/(s(p2,p3))/(s(p3,p4))*s(p1,p4)*nDp1*nDp3 + 20.D0
     &    /(s(p2,p3))/(s(p3,p4))*s(p1,p4)*nDp2*nDp3 + 16.D0/(s(p2,p3))
     &    /(s(p3,p4))*s(p1,p4)*nDp2**2 - 32.D0/(s(p2,p3))/(s(p3,p4))*s(
     &    p2,p4)*nDp1*nDp2 - 18.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)*nDp1*
     &    nDp3 + 8.D0/(s(p2,p3))/(s(p3,p4))*s(p2,p4)*nDp1**2 + 18.D0/(
     &    s(p2,p3))/(s(p3,p4))*s(p2,p4)*nDp2*nDp3 + 8.D0/(s(p2,p3))/(s(
     &    p3,p4))*s(p2,p4)*nDp2**2 + 12.D0/(s(p2,p3))/(s(p3,p4))*s(p2,
     &    p4)*nDp3**2
      c1234 = c1234 - 102.D0/(s(p3,p4))*nDp1*nDp3 - 8.D0/(s(p3,p4))*
     &    nDp1**2 + 18.D0/(s(p3,p4))*nDp2*nDp3 + 8.D0/(s(p3,p4))*
     &    nDp2**2 + 52.D0/(s(p3,p4))*nDp3**2 + 48.D0/(s(p3,p4))/(s(p3,
     &    p4))*s(p1,p2)*nDp3**2 + 48.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p3)*
     &    nDp3**2 + 48.D0/(s(p3,p4))/(s(p3,p4))*s(p1,p4)*nDp3**2 + 48.D0
     &    /(s(p3,p4))/(s(p3,p4))*s(p2,p3)*nDp3**2 + 48.D0/(s(p3,p4))/(
     &    s(p3,p4))*s(p2,p4)*nDp3**2

      return
      end
